; ##########################################################################
; ##########################################################################
;
; File: 		PB2.asm
; Author: 		Ossa
; Description: 	Main source file for PB version 2.1 of Project Build AddIn
;              	for RadASM. Project Build is an AddIn that allows mutiple
;              	source files and multiple output binaries to be built by
;              	RadASM. This version includes a Dialog box for PB Setup.
;
; ##########################################################################
; ##########################################################################

; #############
; Build options
; #############

.386
.MODEL FLAT, STDCALL
option casemap:none

; ###############
; Includes / libs
; ###############

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\masm32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc

include \RadASM\masm\inc\RadASM.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\comdlg32.lib

; ######
; Macros
; ######

m2m MACRO M1, M2
	push M2
	pop M1
ENDM

; #######
; Equates
; #######

IDM_FILE_SAVEALLFILES	equ 40009

MAX_PATHSTR_LEN		EQU	300
MAX_FILES			EQU	300
MAX_LINE_SIZE		EQU	150
MAX_SECTIONS		EQU 30
MAX_BUFF_SIZE		EQU 2000
MAX_CMND_LEN		EQU 1000
MAX_BIGBUFF_LEN		EQU 10000

PH_SUCCESS			EQU 0
PH_ERR				EQU 1

EXTEN_NONE			EQU 0
EXTEN_ASM			EQU 1
EXTEN_DEF			EQU 2
EXTEN_RC			EQU 3

TYPE_WEX			EQU 0
TYPE_CEX			EQU 1
TYPE_DLL			EQU 2
TYPE_LIB			EQU 3
TYPE_UNKNOWN		EQU 4

; ========
; Resource
; ========

; ------
; Dialog
; ------

IDD_PROJOPTS		EQU 1000		; The Project Builder Setup Dialog

; -------
; Buttons
; -------

IDC_ADDFILE			EQU 1007		; Source file - add
IDC_DELFILE			EQU 1014		; Source file - del

IDC_BROWSE_ADD		EQU 1006		; Browse for a new source file to add

IDC_ADDFILEBIN		EQU 1019		; add the currently selected source file to the binary build
IDC_DELFILEBIN		EQU 1020		; delete the currently selected source file from the binary build
IDC_USECURSEL		EQU 1030		; 

IDC_ADDBIN			EQU 1022		; Add a binary file
IDC_DELBIN			EQU 1023		; Delete the current binary build

IDC_OK				EQU 1021		; exit saving changes
IDC_CANCEL			EQU 1018		; exit discarding changes

; ----------
; Edit boxes
; ----------

IDC_NEWSFILE		EQU 1005		; The name of the new file to add
IDC_BINNAME			EQU 1026		; The name of the binary currently being viewed
IDC_SELBOX			EQU 1029		; The index of the def file for the current project
IDC_OUTDIR			EQU 1032		; the output directory of the current binary
IDC_SWITCH			EQU 1034		; the extra switches for the linking of the current directory
IDC_BUILDDIR		EQU 1036		; the directory for all of the build files

; ----
; Tabs
; ----

IDC_BINTAB			EQU 1016		; The tab control for the binaries

; ----------
; List boxes
; ----------

IDC_SOURCE_LIST		EQU 1001		; List of source files
IDC_BINLIST			EQU 1017		; List of source files used for current binary

; -----------
; Combo boxes
; -----------

IDC_TYPEBOX			EQU 1028		; the combo box for binary types

; ##########
; Structures
; ##########

FSection STRUCT
	szName			BYTE MAX_LINE_SIZE dup (?)
FSection ENDS

SFName STRUCT
	szName			BYTE MAX_LINE_SIZE dup (?)
SFName ENDS

BinStruct STRUCT
	szOut			BYTE MAX_LINE_SIZE dup (?)
	szName			BYTE MAX_LINE_SIZE dup (?)
	OBJ_List		BYTE MAX_BUFF_SIZE dup (?)
	szDEF			BYTE MAX_PATHSTR_LEN dup (?)
	szSwitch		BYTE MAX_LINE_SIZE dup (?)
	Type_index		DWORD ?
	nNumObjs		DWORD ?
BinStruct ENDS

ADDINOPT struct
	lpStr			dd ?
	nAnd			dd ?
	nOr				dd ?
ADDINOPT ends

; ######
; Protos
; ######

Main					PROTO									;									ret: NOTHING
SetPathCorrect			PROTO									;									ret: NOTHING
GetSections				PROTO									;									ret: NOTHING
GetSFiles				PROTO									;									ret: NOTHING
udwtoa 					PROTO :DWORD, :DWORD					; Val, szStr						ret: NOTHING
AssembleFiles			PROTO									;									ret: ERR_CODE
MakeBuildNames			PROTO									;									ret: NOTHING
GetExtension 			PROTO :DWORD							; pName								ret: EXTEN_CODE
GetFName				PROTO :DWORD, :DWORD					; pOName, pFName					ret: NOTHING
PipeCmnd				PROTO :DWORD							; pCmndLine							ret: ERR_CODE
LinkFile				PROTO :DWORD							; SectionID							ret: ERR_CODE
GetBinType				PROTO :DWORD							; SectionID							ret: BIN_TYPE
MakeOBJSwitchList		PROTO :DWORD, :DWORD					; SectionID, pBuff					ret: NOTHING
LinkFiles				PROTO									;									ret: ERR_CODE
GetStrToComma			PROTO :DWORD, :DWORD					; pDest, pSrc						ret: NOTHING
SendBBuff 				PROTO 									;									ret: NOTHING
DllEntry 				PROTO :HINSTANCE, :DWORD, :DWORD 		; hInst, dwReason, dwRes1			ret: TRUE
InstallDll 				PROTO :DWORD, :DWORD					; hWin, fOpt						ret: RAM_CODES
DllProc 				PROTO :HWND, :UINT, :WPARAM, :LPARAM	; hWin, uMsg, wParam, lParam		ret: ZERO
DlgProc 				PROTO :HWND, :UINT, :WPARAM, :LPARAM	; hWin, uMsg, wParam, lParam		ret: TRUE/FALSE
PInfoExists				PROTO									;									ret: TRUE/FALSE
StripCurPath			PROTO :DWORD, :DWORD					; pDest, pSrc						ret: NOTHING
SaveCurBin 				PROTO :HWND								; hWin								ret: TRUE/FALSE
LoadBin 				PROTO :HWND								; hWin								ret: NOTHING
NewBin 					PROTO :HWND								; hWin								ret: NOTHING
DelAllInBLBox 			PROTO :HWND								; hWin								ret: NOTHING
MoveTab 				PROTO :DWORD, :DWORD					; To, From							ret: NOTHING
RenameTabs 				PROTO :HWND								; hWin								ret: NOTHING
LoadPInfo 				PROTO :HWND								; hWin								ret: TRUE/FALSE
LoadFilesLB 			PROTO :HWND								; hWin								ret: NOTHING
LoadBinPInfo 			PROTO :HWND, :DWORD, :DWORD				; hWIn, pBin, Count					ret: NOTHING
GetOBJSFromFile 		PROTO :HWND, :DWORD						; SectionID							ret: NOTHING
CopySFName 				PROTO :DWORD, :DWORD					; SFNum, szDest						ret: NOTHING
DoDlgPaths 				PROTO :HWND								; hWin								ret: NOTHING
NumBEqual 				PROTO :DWORD, :DWORD					; pStr1, pStr2						ret: NUM
IsPathFull 				PROTO :DWORD							; pPath								ret: NUM
CopySFNamesToBuffer		PROTO :HWND								; hWin								ret: NOTHING
GetSFNameRoot 			PROTO :DWORD							; pBuf								ret: NOTHING
AlterSFNames 			PROTO									;									ret: NOTHING
GetNextSFNotFullPath 	PROTO :DWORD							; dwIndex							ret: NOTHING
StringIndexToFile 		PROTO :DWORD, :HWND, :DWORD				; pBuf, hWin, pString				ret: NOTHING
OBJListToStr 			PROTO :DWORD, :HWND, :DWORD				; pBuf, hWin, OBJIndex				ret: TRUE/FALSE
BinToStr 				PROTO :DWORD, :HWND, :DWORD				; pBuf, hWin, OBJIndex				ret: TRUE/FALSE
TypeToStr 				PROTO :DWORD, :DWORD					; pBuf, FType						ret: TRUE/FALSE
AppendSFiles 			PROTO :DWORD							; pBuf								ret: NOTHING
SaveToFile 				PROTO :HWND								; hWin								ret: TRUE/FALSE
IsProjectOpen 			PROTO									;									ret: TRUE/FALSE
BinaryExists 			PROTO :DWORD, :DWORD, :HWND				; pName, iIgnore, hWin				ret: TRUE/FALSE
CopyRealStem 			PROTO :DWORD, :DWORD					; pDest, pSrc						ret: NOTHING
OutFileAlreadyExists 	PROTO :DWORD, :DWORD					; pFile, nNumFiles					ret: TRUE/FALSE
MakeRelReal 			PROTO :DWORD, :DWORD					; pFile, nNumFiles					ret: NOTHING
CreateBldDirTree 		PROTO									;									ret: NOTHING
MakeSubPath 			PROTO :DWORD, :DWORD					; szPath, szAdd						ret: NOTHING
GetFileSubPath 			PROTO :DWORD, :DWORD					; szPath, iFileOffs					ret: NOTHING
GetFirstFolder 			PROTO :DWORD, :DWORD					; szDest, szPath					ret: NOTHING
ParseCurBin 			PROTO :DWORD							; hWin								ret: TRUE/FALSE

; #######
; Strings
; #######

.data

szProjInfoFile		db "PInfo.dat", 0
szSFiles			db "sfiles", 0
szFolders			db "folders", 0
szBuild				db "BUILD", 0
szSource			db "SOURCE", 0
szOut				db "OUT", 0
szType				db "TYPE", 0
szDef				db "DEF", 0
szObj				db "OBJ", 0
szSwitch			db "SWITCH", 0
szBinary			db "Binary ", 0

szFilter			db "Source Files (*.def, *.asm, *.rc)", 0, "*.def;*.asm;*.rc", 0, "All Files (*.*)", 0, "*.*", 0, 0
szOpenTitle			db "Select Source File", 0

szPBTag				db "Project Builder version 2.1", 0
szFileMustFrom		db "Source files must be selected from within the project directory!", 0
szMust1Bin			db "Projects must contain at least one binary!", 0
szPInfoNoData		db "The file PInfo.dat used by PB exists, but contains insufficient data for use: Creating new project file", 0
szSFNotFound		db "One or more source files that are used in Binaries are no longer in the source file list!", 0dh, 0ah, "Please reinsert them to the source list or remove them from the binary lists", 0
szBinAlrdEx			db "A Binary with the specified name already exists!", 0
szBinMustName		db "All binaries must have names!", 0
szBuildError		db "Error building file(s)", 0dh, 0ah, 0
szFileError			db "Error reading PInfo.dat", 0dh, 0ah, 0

szEndChar			db "#", 0
szSpcStr			db " ", 0
szEquals			db "=", 0
szComma				db ",", 0
szOpenSqBrac		db "[", 0
szCloseSqBrac		db "]", 0
szNULLStr			db 0
szRetStr			db 0Dh, 0Ah, 0
szLinking			db " Linking:    ", 0
szLibbing			db " Making Lib: ", 0
szBuilding			db " Compiling:  ", 0
szOtherDirBuild		db "OtherDirs\", 0

szWSPF_RC1_Str		db "\masm32\bin\rc /Fo%s %s", 0																; Out (.res), In (.rc)
szWSPF_RC2_Str		db "\masm32\bin\cvtres /nologo /machine:ix86 /out:%s %s", 0									; Out (.obj), In (.res)
szWSPF_ASM_Str		db "\masm32\bin\ml /c /coff /nologo /Fo%s %s", 0											; Out (.obj), In (.asm)
szWSPF_WEX_Str		db "\masm32\bin\Link /OUT:%s /nologo /MACHINE:IX86 /SUBSYSTEM:WINDOWS %s", 0				; Out (.exe), InList+Switch (.obj)
szWSPF_CEX_Str		db "\masm32\bin\Link /OUT:%s /nologo /MACHINE:IX86 /SUBSYSTEM:CONSOLE %s", 0				; Out (.exe), InList+Switch (.obj)
szWSPF_DLL_Str		db "\masm32\bin\Link /OUT:%s /nologo /MACHINE:IX86 /DLL /DEF:%s /SUBSYSTEM:WINDOWS %s", 0	; Out (.dll), Def (.def), InList+Switch (.obj)
szWSPF_LIB_Str		db "\masm32\bin\Link -lib /nologo /OUT:%s %s", 0											; Out (.lib), InList+Switch (.obj)

szExt_ASM			db ".asm", 0
szExt_RC			db ".rc", 0
szExt_DEF			db ".def", 0
szExt_OBJ			db ".obj", 0
szExt_RES			db ".res", 0
szExt_EXE			db ".exe", 0
szExt_DLL			db ".dll", 0
szExt_LIB			db ".lib", 0

szType_WEX			db "EXE_WINDOWS", 0
szType_CEX			db "EXE_CONSOLE", 0
szType_DLL			db "DLL", 0
szType_LIB			db "LIB", 0

szBuildProjectMult	db "PB: &Build Project", 0
szEditPBOpts		db "PB: Edit Pr&oject Settings", 0

szCB_WEX			db "Windows Executable (.EXE)", 0
szCB_CEX			db "Console Executable (.EXE)", 0
szCB_DLL			db "Dynamic-Link Library (.DLL)", 0
szCB_LIB			db "Static Library (.LIB)", 0

szTrue				db "TRUE", 0
szFalse				db "FALSE", 0

szEnablePB			db "Enable project builder",0
AddinOpt			ADDINOPT <offset szEnablePB,1,1>
					ADDINOPT <0,0,0>

; ##################
; Uninitialised data
; ##################

.data?

FileBuff			db MAX_BUFF_SIZE dup (?)
szCurFile			db MAX_PATHSTR_LEN dup (?)
szCurPath			db MAX_PATHSTR_LEN dup (?)

OBJList				SFName MAX_FILES dup (<>)
SFNameList			SFName MAX_FILES dup (<>)
NumFiles			dd ?

SectionList			FSection MAX_SECTIONS dup (<>)
NumSections			dd ?

szBuildPath			db MAX_PATHSTR_LEN dup (?)
szSourcePath		db MAX_PATHSTR_LEN dup (?)
PStr				db MAX_PATHSTR_LEN dup (?)

BSList				BinStruct MAX_SECTIONS dup (<>)

ofn					OPENFILENAME <>
hInstance			HINSTANCE ?
lpHStruct			dd ?
lpPStruct			dd ?
lpDStruct			dd ?
hWnd				dd ?
hOut				dd ?
bRunning			db ?
nMenuID				dd ?
pBigBuff			dd ?
nMenuDlgID			dd ?

bChangeBack			dd ?
iChangeTo			dd ?

; ####
; Code
; ####

.code

; *********************************
; Gets instance handle and saves it
; *********************************

DllEntry PROC hInst:HINSTANCE, dwReason:DWORD, dwRes1:DWORD
    m2m hInstance, hInst
    mov eax, TRUE
    ret
DllEntry ENDP

GetOptions proc
	mov		eax,offset AddinOpt
	ret
GetOptions endp

; ***************************
; Sets up options with RadASM
; ***************************

InstallDll PROC hWin:DWORD, fOpt:DWORD
	LOCAL	hMnu:DWORD
	LOCAL	mnui:MENUITEMINFO

	; ==========================
	; Save window & get pointers
	; ==========================

	m2m hWnd, hWin
	invoke SendMessage, hWin, AIM_GETHANDLES, 0, 0
	mov lpHStruct, eax
	invoke SendMessage, hWin, AIM_GETPROCS, 0, 0
	mov lpPStruct, eax
	invoke SendMessage, hWin, AIM_GETDATA, 0, 0
	mov lpDStruct, eax

	; ====================
	; Init common controls
	; ====================

	invoke InitCommonControls

	; ============
	; Check option
	; ============
	
	mov eax, fOpt
	.if eax!=0
	
		; ==============
		; Set menu items
		; ==============
	
		invoke SendMessage, hWin, AIM_GETMENUID, 0, 0
		mov nMenuID, eax
		invoke SendMessage, hWin, AIM_GETMENUID, 0, 0
		mov nMenuDlgID, eax
		
		; ===============
		; Get menu handle
		; ===============

		mov	edx,4

		mov	eax, [lpDStruct]
		test [eax][ADDINDATA.fMaximized], 0FFFFFFFFh
		jz @F
		inc	edx
@@:

		; ===========================
		; Get handle of Project popup
		; ===========================

		mov	eax, [lpHStruct]
		invoke GetSubMenu, [eax][ADDINHANDLES.hMenu], edx
		mov	hMnu, eax

		invoke AppendMenu, hMnu, MF_SEPARATOR, NULL, NULL
		invoke AppendMenu, hMnu, MF_STRING, nMenuDlgID, addr szEditPBOpts
		invoke AppendMenu, hMnu, MF_STRING, nMenuID, addr szBuildProjectMult
	.endif

	; =====================
	; Hook into AIM_COMMAND
	; =====================

	mov eax, RAM_COMMAND or RAM_INITMENUPOPUP
	xor ecx, ecx
	xor edx, edx
    ret
InstallDll ENDP

; **********************
; Handle RadASM messages
; **********************

DllProc PROC hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hMnu:DWORD
	
	; ==================================
	; Check for the correct message type
	; ==================================

	mov eax, uMsg
	.if eax==AIM_COMMAND
	
		; ==========================================
		; Command - check if it has our menu command
		; ==========================================
		
		mov eax, wParam
		and eax, 00000FFFFh
		.if eax==nMenuID
		
			; ==============
			; Save all files
			; ==============
			
			mov eax, lpHStruct
			invoke SendMessage, [eax][ADDINHANDLES.hWnd], WM_COMMAND, IDM_FILE_SAVEALLFILES, 0

			; =================
			; Build the project
			; =================
			
			; --------------------------------------
			; Allocate a buffer for temporary output
			; --------------------------------------
		
			invoke GlobalAlloc, GMEM_FIXED, MAX_BIGBUFF_LEN
			.if eax==0
				ret
			.endif
			mov pBigBuff, eax
			
			; -------------------------
			; Make it a 0 length string
			; -------------------------
			
			xor ecx, ecx
			mov [eax], cl

			; -----------------------------------------------------
			; Copy the current project path to the correct position
			; -----------------------------------------------------
			
			mov edi, [lpDStruct]
			invoke lstrcpy, addr szCurPath, [edi][ADDINDATA.lpProjectPath]

			; -----------------------
			; Clear the output window
			; -----------------------

			mov eax, [lpPStruct]
			call (ADDINPROCS ptr [eax]).lpClearOut
			
			; ------------
			; Do the build
			; ------------
			
			invoke Main
			
			; ------------------
			; Dealloc the buffer
			; ------------------

			invoke GlobalFree, pBigBuff
			
			; ---------------------------------------------------------------------
			; set the output box so that it recognises the contents as Build output
			; ---------------------------------------------------------------------
			
			mov edi, [lpDStruct]
			mov [edi][ADDINDATA.AsmFlag], TRUE
			
		.elseif eax==nMenuDlgID
			
			; =================
			; Create the dialog
			; =================
			
			invoke CreateDialogParam, hInstance, IDD_PROJOPTS, hWnd, addr DlgProc, 0
			
		.endif
	.elseif eax==AIM_INITMENUPOPUP
	
		; =============================
		; do appropriate enable/disable
		; =============================

		mov eax, lpHStruct
		mov eax, [eax][ADDINHANDLES.hMenu]

		; ===============
		; Get menu handle
		; ===============

		mov	edx,4

		mov	eax, [lpDStruct]
		test [eax][ADDINDATA.fMaximized], 0FFFFFFFFh
		jz @F
		inc	edx
@@:

		; ===========================
		; Get handle of Project popup
		; ===========================

		mov	eax, [lpHStruct]
		invoke GetSubMenu, [eax][ADDINHANDLES.hMenu], edx
		mov	hMnu, eax

		invoke IsProjectOpen
		.if eax==TRUE
			mov ecx, MF_ENABLED
		.else
			mov ecx, MF_GRAYED
		.endif
		
		push ecx
		invoke EnableMenuItem, hMnu, nMenuDlgID, ecx
		pop ecx
		invoke EnableMenuItem, hMnu, nMenuID, ecx
	.endif

	; ================
	; return to RadASM
	; ================
	
	xor eax, eax
	ret
DllProc ENDP

; **********************************
; Controls the main building process
; **********************************

Main PROC

	; ===============================================================
	; Set it so that the path for the PInfo.dat file is set correctly
	; ===============================================================
	
	invoke SetPathCorrect
	
	; ================================================
	; read the section headers form the pinfo.dat file
	; ================================================
	
	invoke GetSections
	.if NumSections<=2
		invoke lstrcpy, pBigBuff, addr szFileError
		ret
	.endif
	
	; ========================================
	; read the source file list from pinfo.dat
	; ========================================
	
	invoke GetSFiles
	.if NumFiles==0
		invoke lstrcpy, pBigBuff, addr szFileError
		ret
	.endif
	
	; =======================================
	; Setup the intermediate build file names
	; =======================================
	
	invoke MakeBuildNames
	
	; =======================================
	; Make the build directory tree structure
	; =======================================
	
	invoke CreateBldDirTree
	
	; ===========================================
	; Assemble asm files and build resource files
	; ===========================================

	invoke AssembleFiles
	.if eax==PH_ERR
		invoke lstrcpy, pBigBuff, addr szBuildError
		ret
	.endif
	
	; =================
	; Make the binaries
	; =================
	
	invoke LinkFiles
	.if eax==PH_ERR
		invoke lstrcpy, pBigBuff, addr szBuildError
		ret
	.endif
	ret
Main ENDP

; ***********************************************************************************
; Sets the current path to the correct value and sets up the pinfo.dat path/file name
; ***********************************************************************************

SetPathCorrect PROC

	; =======================================================================
	; Check if the last letter in the path is a backslash and if not, add one
	; =======================================================================

	invoke lstrlen, addr szCurPath
	add eax, offset szCurPath
	mov cl, [eax-1]

	.if cl!=5Ch
		mov cx, 005Ch
		mov [eax], cl
		mov [eax+1], ch
	.endif
	
	; =========================
	; Set the current directory
	; =========================

	invoke SetCurrentDirectory, addr szCurPath

	; =============================
	; Setup the pinfo.dat path/name
	; =============================

	invoke lstrcpy, addr szCurFile, addr szCurPath
	invoke lstrcat, addr szCurFile, addr szProjInfoFile
	
	; ====================
	; set the path to NULL
	; ====================
	
	invoke lstrcpy, addr szCurPath, addr szNULLStr
	
	ret
SetPathCorrect ENDP

; *******************************************
; Gets the section names fro mth PIfodat file
; *******************************************

GetSections PROC
	LOCAL NumBytes:DWORD
	LOCAL CurPB:DWORD
	LOCAL CurPS:DWORD

	; =====================================
	; Get the section NULL seperated string
	; =====================================

	invoke GetPrivateProfileSectionNames, addr FileBuff, MAX_BUFF_SIZE, addr szCurFile
	mov NumBytes, eax

	; ==============================
	; Setup the pointers and counter
	; ==============================
	
	mov edi, offset FileBuff
	mov CurPB, edi
	mov edi, offset SectionList
	mov CurPS, edi
	xor eax, eax
	mov NumSections, eax

GetDataFromFile_Loop:	

	; =================
	; Save the sections
	; =================

	; ----------------------------------------------------------------------------------------------
	; Check the string is not 0 length as this would indicate the end of the section multiple string
	; ----------------------------------------------------------------------------------------------
	
	invoke lstrlen, CurPB
	test eax, eax
	jnz @F
	ret
@@:

	; -------------------------------
	; switch the string to lower case
	; -------------------------------

	invoke lcase, CurPB
	
	; --------------------------------------------
	; copy the string to the list of section names
	; --------------------------------------------
	
	invoke lstrcpy, CurPS, CurPB
	
	; --------------------------------------------------------------------
	; increase the multiple string counter by the length of the string + 1
	; --------------------------------------------------------------------
	
	invoke lstrlen, CurPB
	add eax, CurPB
	inc eax
	mov CurPB, eax
	
	; -----------------------------------------
	; increment the section name struct pointer
	; -----------------------------------------
	
	mov eax, CurPS
	add eax, sizeof FSection
	mov CurPS, eax
	
	; --------------------------------
	; increment the number of sections
	; --------------------------------
	
	inc NumSections

	; ------------
	; restart loop
	; ------------

	jmp GetDataFromFile_Loop
GetSections ENDP

; *************************
; Get the source file names
; *************************

GetSFiles PROC
	LOCAL szReturnStr[MAX_LINE_SIZE]:BYTE
	LOCAL szCurNumStr[50]:BYTE
	LOCAL CurPN:DWORD
	
	; ===================================
	; Get the build and source file paths
	; ===================================
	
	invoke GetPrivateProfileString, addr szFolders, addr szBuild, addr szNULLStr, addr szBuildPath, MAX_PATHSTR_LEN, addr szCurFile
	invoke GetPrivateProfileString, addr szFolders, addr szSource, addr szNULLStr, addr szSourcePath, MAX_PATHSTR_LEN, addr szCurFile

	; ====================================
	; Setup counters and pointers for loop
	; ====================================
	
	xor eax, eax
	mov NumFiles, eax
	mov eax, offset SFNameList
	mov CurPN, eax
	
GetSFiles_Loop:

	; ==============
	; Set num string
	; ==============
	
	mov ecx, NumFiles
	inc ecx
	invoke udwtoa, ecx, addr szCurNumStr
	
	; ==============
	; Get the string
	; ==============
	
	invoke GetPrivateProfileString, addr szSFiles, addr szCurNumStr, addr szEndChar, addr szReturnStr, MAX_LINE_SIZE, addr szCurFile
	
	; ================
	; Check the string
	; ================
	
	invoke lstrcmp, addr szReturnStr, addr szEndChar
	.if eax==0
		
		; ======
		; Finish
		; ======
		
		ret
	.endif
	
	; ==================
	; Copy to SFNameList
	; ==================
	
	invoke lcase, addr szReturnStr
	invoke lstrcpy, CurPN, addr szReturnStr
	
	; ==============
	; Inc all things
	; ==============
	
	mov eax, CurPN
	add eax, SFName
	mov CurPN, eax
	
	mov ecx, NumFiles
	inc ecx
	mov NumFiles, ecx

	jmp GetSFiles_Loop
GetSFiles ENDP

; *************************************
; convert an unsigned dword to a string
; *************************************

udwtoa PROC Val:DWORD, szStr:DWORD
    mov edi, szStr

	; ========================================
	; get the lagest power of 10 less than Val
	; ========================================

    mov eax, Val
    .if eax>=1000000000
        mov ecx, 1000000000
    .elseif eax>=100000000
        mov ecx, 100000000
    .elseif eax>=10000000
        mov ecx, 10000000
    .elseif eax>=1000000
        mov ecx, 1000000
    .elseif eax>=100000
        mov ecx, 100000
    .elseif eax>=10000
        mov ecx, 10000
    .elseif eax>=1000
        mov ecx, 1000
    .elseif eax>=100
        mov ecx, 100
    .elseif eax>=10
        mov ecx, 10
    .else
        mov ecx, 1
    .endif

udwtoa_loop:

	; ==========================================================================
	; use the current value of val to get its multiple of the current base of 10
	; ==========================================================================
	
    xor edx, edx
    div ecx
    
    ; ==============================================================================
    ; convert it to an ascii value and save it to the current position in the string
    ; ==============================================================================
    
    add al, 30h
    mov [edi], al
    
    ; ==============================
    ; incrememnt the string position
    ; ==============================
    
    inc edi
    
    .if ecx==1
    	; ============================================================================================================
    	; if we were getting the units then exit - we are finished (but put a null char on the end of the string first
    	; ============================================================================================================
    
        mov dl, 00h
        mov [edi], dl
        mov eax, TRUE
        ret
    .endif

	; =============================================
	; save val modulo ecx (our current power of 10)
	; =============================================

    push edx
    
    ; ================
    ; divide ecx by 10
    ; ================
    
    mov eax, ecx
    xor edx, edx
    mov ecx, 10
    div ecx
    mov ecx, eax
    
    ; ================
    ; get back our val
    ; ================
    
    pop eax
    
    ; ==================
    ; jump to loop start
    ; ==================
    
    jmp udwtoa_loop
udwtoa ENDP

; **********************
; Assemble all the files
; **********************

AssembleFiles PROC
	LOCAL pCurName:DWORD
	LOCAL pOutName:DWORD
	LOCAL szCmndLine[MAX_CMND_LEN]:BYTE
	LOCAL FilesLeft:DWORD
	
	; ==========
	; Setup loop
	; ==========
	
	m2m FilesLeft, NumFiles
	mov eax, offset OBJList
	mov pOutName, eax
	mov eax, offset SFNameList
	mov pCurName, eax

AssembleFiles_LoopStart:

	; ==============================
	; Get file extension & file stem
	; ==============================
	
	invoke GetExtension, pCurName
	
	; =============
	; Choose action
	; =============
	
	.if eax==EXTEN_ASM
	
		; ======================
		; setup the command line
		; ======================
	
		invoke wsprintf, addr szCmndLine, addr szWSPF_ASM_Str, pOutName, pCurName
		
		; =====================================
		; run the command and output its output
		; =====================================
		
		invoke PipeCmnd, addr szCmndLine
		
		; ===========================
		; check for an assemble error
		; ===========================
		
		.if eax==PH_ERR
			ret
		.endif

	.elseif eax==EXTEN_RC
	
		; =================================
		; say that we're building something
		; =================================

		invoke lstrcpy, pBigBuff, addr szBuilding
		invoke lstrcat, pBigBuff, pCurName
		invoke SendBBuff
		
		; ===============================
		; setup the res intermediate file
		; ===============================

		invoke GetFName, addr FileBuff, pOutName
		invoke lstrcat, addr FileBuff, addr szExt_RES
		
		; ===================================
		; setup the res building command line
		; ===================================
		
		invoke wsprintf, addr szCmndLine, addr szWSPF_RC1_Str, addr FileBuff, pCurName
		
		; =====================================
		; run the command and output its output
		; =====================================
		
		invoke PipeCmnd, addr szCmndLine
		
		; ==================
		; check for an error
		; ==================
		
		.if eax==PH_ERR
			ret
		.endif
		
		; ===================================
		; setup the obj building command line
		; ===================================
		
		invoke wsprintf, addr szCmndLine, addr szWSPF_RC2_Str, pOutName, addr FileBuff

		; =====================================
		; run the command and output its output
		; =====================================
		
		invoke PipeCmnd, addr szCmndLine
		
		; ==================
		; check for an error
		; ==================
		
		.if eax==PH_ERR
			ret
		.endif
		
	.endif
	
	; ===================
	; setup for next loop
	; ===================
	
	; -------------------------------------------
	; check for end condition & decrement counter
	; -------------------------------------------
	
	mov eax, FilesLeft
	dec eax
	test eax, eax
	jnz @F
	ret
@@:
	mov FilesLeft, eax

	; ------------------
	; increment pointers
	; ------------------
	
	mov eax, pCurName
	add eax, sizeof SFName
	mov pCurName, eax
	
	mov eax, pOutName
	add eax, sizeof SFName
	mov pOutName, eax

	; ======================
	; Jump to the loop start
	; ======================
	
	jmp AssembleFiles_LoopStart
AssembleFiles ENDP

; **********************************
; Makes the intermediate build names
; **********************************

MakeBuildNames PROC
	LOCAL pCurName:DWORD
	LOCAL pOutName:DWORD
	LOCAL szStem[MAX_PATHSTR_LEN]:BYTE
	LOCAL szOutF[MAX_PATHSTR_LEN]:BYTE
	LOCAL FilesLeft:DWORD
	
	; ==========
	; Setup loop
	; ==========
	
	mov FilesLeft, 00000000h
	mov pOutName, offset OBJList
	mov pCurName, offset SFNameList

AssembleFiles_LoopStart:

	invoke lstrcpy, pOutName, addr szNULLStr

	; ===========================
	; What sort of filename is it
	; ===========================
	
	invoke IsPathFull, pCurName
	.if eax==TRUE
		
		; ===================================
		; Get file extension & real file stem
		; ===================================
		
		invoke CopyRealStem, addr szStem, pCurName
		invoke GetExtension, pCurName

		; =============
		; Choose action
		; =============
		
		.if (eax==EXTEN_ASM) || (eax==EXTEN_RC)
			invoke lstrcpy, pOutName, addr szBuildPath
			invoke lstrcat, pOutName, addr szOtherDirBuild
			invoke lstrcat, pOutName, addr szStem
			invoke MakeRelReal, pOutName, FilesLeft
			invoke lstrcat, pOutName, addr szExt_OBJ
		.else
			invoke lstrcpy, pOutName, pCurName
		.endif

	.else

		; ==============================
		; Get file extension & file stem
		; ==============================
		
		invoke GetFName, addr szStem, pCurName
		invoke GetExtension, pCurName
		
		; =============
		; Choose action
		; =============
		
		.if (eax==EXTEN_ASM) || (eax==EXTEN_RC)
			invoke lstrcpy, pOutName, addr szBuildPath
			invoke lstrcat, pOutName, addr szStem
			invoke MakeRelReal, pOutName, FilesLeft
			invoke lstrcat, pOutName, addr szExt_OBJ
		.else
			invoke lstrcpy, pOutName, addr szSourcePath
			invoke lstrcat, pOutName, pCurName
		.endif
		invoke lstrcpy, addr szOutF, pCurName
		invoke lstrcpy, pCurName, addr szCurPath
		invoke lstrcat, pCurName, addr szSourcePath
		invoke lstrcat, pCurName, addr szOutF
	.endif
	
	; ===================
	; setup for next loop
	; ===================
	
	; ---------------------------------------------------------------------
	; check the number of files left and decrement - resave the Number left
	; ---------------------------------------------------------------------
	
	mov eax, FilesLeft
	inc eax
	cmp eax, NumFiles
	jne @F
	ret
@@:
	mov FilesLeft, eax
	
	; ------------------------------------------------
	; increment the name pointers by the string length
	; ------------------------------------------------

	mov eax, pCurName
	add eax, sizeof SFName
	mov pCurName, eax
	
	mov eax, pOutName
	add eax, sizeof SFName
	mov pOutName, eax
	
	; ------------------
	; Jump to loop start
	; ------------------
	
	jmp AssembleFiles_LoopStart
MakeBuildNames ENDP

; ****************************************************
; Gets the extension of a file in the specified string
; ****************************************************

GetExtension PROC pName:DWORD
	LOCAL pExt:DWORD

	; ===============================================================
	; Check that the name string is large enough to have an extension
	; ===============================================================

	invoke lstrlen, pName
	.if eax<4
		mov eax, EXTEN_NONE
		ret
	.endif
	
	; =================================================
	; get a pointer to the extension (including th '.')
	; =================================================
	
	add eax, pName
	sub eax, 4
	mov cl, [eax]
	cmp cl, '.'
	je @F
	
	; =============================
	; check for a shorter extension
	; =============================
	
	inc eax
	mov cl, [eax]
	cmp cl, '.'
	je @F
	
	; ------------------
	; no '.' found, exit
	; ------------------
	
	mov eax, EXTEN_NONE
	ret
@@:

	; ------------
	; save pointer
	; ------------

	mov pExt, eax
	
	; ===========================
	; compare all extension types
	; ===========================

	invoke lstrcmp, pExt, addr szExt_ASM
	.if eax==0
		mov eax, EXTEN_ASM
		ret
	.endif

	invoke lstrcmp, pExt, addr szExt_DEF
	.if eax==0
		mov eax, EXTEN_DEF
		ret
	.endif

	invoke lstrcmp, pExt, addr szExt_RC
	.if eax==0
		mov eax, EXTEN_RC
		ret
	.endif

	; ===============================
	; not recognised, say so and exit
	; ===============================
	
	mov eax, EXTEN_NONE
	ret
GetExtension ENDP

; ************************************************************
; Gets the Name stem (name minus the extension) of a file name
; ************************************************************

GetFName PROC pOName:DWORD, pFName:DWORD
	LOCAL pExt:DWORD

	; ===============================================================
	; Check that the name string is large enough to have an extension
	; ===============================================================

	invoke lstrlen, pFName
	.if eax<4
		mov eax, pOName
		xor cl ,cl
		mov [eax], cl
		ret
	.endif
	
	; =================================================
	; get a pointer to the extension (including th '.')
	; =================================================
	
	add eax, pFName
	sub eax, 4
	mov cl, [eax]
	cmp cl, '.'
	je @F

	; =============================
	; check for a shorter extension
	; =============================
	
	inc eax
	mov cl, [eax]
	cmp cl, '.'
	je @F

	; ------------------
	; no '.' found, exit
	; ------------------
	
	mov eax, pOName
	xor cl, cl
	mov [eax], cl
	ret
@@:

	; =========================================================
	; now use it to get the length of the string before the '.'
	; =========================================================

	sub eax, pFName
	
	; =====================
	; setup the string copy
	; =====================
	
	mov ecx, eax
	mov edi, pOName
	mov esi, pFName
	rep movsb

	; ========================
	; make the null terminator
	; ========================

	xor al, al
	mov [edi], al

	; ====
	; exit
	; ====

	ret
GetFName ENDP

; ******************************************************************
; Set up the process for assembling/linking and output to the window
; ******************************************************************

PipeCmnd PROC pCmndLine:DWORD
	LOCAL startupinfo:STARTUPINFO
	LOCAL pinfo:PROCESS_INFORMATION
	LOCAL sat:SECURITY_ATTRIBUTES
	LOCAL bytesRead:DWORD
	LOCAL ExitCode:DWORD
	LOCAL hRead:DWORD
	LOCAL hWrite:DWORD
	
	; ==========================
	; Make the pipe (annonymous)
	; ==========================

	mov sat.nLength, sizeof SECURITY_ATTRIBUTES
	mov sat.lpSecurityDescriptor, NULL
	mov sat.bInheritHandle, TRUE
	invoke CreatePipe, addr hRead, addr hWrite, addr sat, NULL

	; =============
	; exit on error
	; =============

	.if eax==NULL
		mov eax, PH_ERR
		ret
	.endif

	; ===============================================
	; setup the process startinfo for the commandline
	; ===============================================

	mov startupinfo.cb, sizeof STARTUPINFO
	invoke GetStartupInfo, addr startupinfo

	mov eax, hWrite
	mov startupinfo.hStdOutput, eax
	mov startupinfo.hStdError, eax
	mov startupinfo.dwFlags, STARTF_USESHOWWINDOW + STARTF_USESTDHANDLES
	mov startupinfo.wShowWindow, SW_HIDE

	; ==================
	; create the process
	; ==================

	invoke CreateProcess, NULL, pCmndLine, NULL, NULL, TRUE, NULL, NULL, NULL, addr startupinfo, addr pinfo
	.if eax==NULL
		mov eax, PH_ERR
		ret
	.endif

	; =========================
	; no need to write, so exit
	; =========================

	invoke CloseHandle, hWrite

	; =====================================================
	; Read in the lines outputted from the assembler/linker
	; =====================================================

PipeCmnd_ReadLoop:
	invoke ReadFile, hRead, pBigBuff, MAX_BIGBUFF_LEN, addr bytesRead, NULL
	.if eax!=NULL
		
		; ---------------------------------------------
		; set the null char at the end of the read data
		; ---------------------------------------------
	
		mov edi, bytesRead
		add edi, pBigBuff
		xor al, al
		mov [edi], al

		; ------------------------------
		; Send the data to output window
		; ------------------------------

		invoke SendBBuff

		; ----------------------
		; jump to readloop start
		; ----------------------

		jmp PipeCmnd_ReadLoop
	.endif

	; =======================================
	; Reading complete: close the read handle
	; =======================================

	invoke CloseHandle, hRead

PipeCmnd_ProcExitCodeLoop:

	; =========================================================================
	; Check the process exit state - if its still going, wait until it finishes
	; =========================================================================

	invoke GetExitCodeProcess, pinfo.hProcess, addr ExitCode
	mov eax, ExitCode
	cmp eax, STILL_ACTIVE
	je PipeCmnd_ProcExitCodeLoop

	; ====================================
	; Close the process and thread handles
	; ====================================

	invoke CloseHandle, pinfo.hProcess
	invoke CloseHandle, pinfo.hThread

	; ========================================
	; Exit correctly depending on the exitcode
	; ========================================

	mov eax, ExitCode
	.if eax==0
		mov eax, PH_SUCCESS
	.else
		mov eax, PH_ERR
	.endif

	ret
PipeCmnd ENDP

; **************************************************************
; Link the files for a specific binary in the appropriate manner
; **************************************************************

LinkFile PROC SectionID:DWORD
	LOCAL szCmndLine[MAX_CMND_LEN]:BYTE
	LOCAL szTmpStr[MAX_PATHSTR_LEN]:BYTE
	LOCAL szTmp2Str[MAX_CMND_LEN]:BYTE

	; ======================================
	; Get the type of file we are linking to
	; ======================================

	invoke GetBinType, SectionID
	
	.if eax==TYPE_WEX
	
		; ========================================================
		; This is a windows executable, so get its output sub path
		; ========================================================

		mov edi, offset SectionList
		mov eax, sizeof FSection
		mul SectionID
		add edi, eax
		invoke GetPrivateProfileString, edi, addr szOut, addr szNULLStr, addr szTmpStr, MAX_PATHSTR_LEN, addr szCurFile
		
		; ============
		; get its name
		; ============
		
		mov edi, offset SectionList
		mov eax, sizeof FSection
		mul SectionID
		add edi, eax
		
		; =================================================================
		; concatenate the name and file extension (.EXE) to the path string
		; =================================================================
		
		invoke lstrcat, addr szTmpStr, edi
		invoke lstrcat, addr szTmpStr, addr szExt_EXE
		
		; ============================================================
		; give some output, so that they know we are linking this file
		; ============================================================

		invoke lstrcpy, pBigBuff, addr szLinking
		invoke lstrcat, pBigBuff, addr szTmpStr
		invoke SendBBuff

		; =========================================================
		; Make the string with the extra switches and the .obj list
		; =========================================================

		invoke MakeOBJSwitchList, SectionID, addr szTmp2Str
		
		; ====================================================
		; make the commandline from all other strings obtained
		; ====================================================
		
		invoke wsprintf, addr szCmndLine, addr szWSPF_WEX_Str, addr szTmpStr, addr szTmp2Str
		
		; =================================================
		; Run the linker and get the output from the linker
		; =================================================

		invoke PipeCmnd, addr szCmndLine

		; ==========================
		; sort out the return values
		; ==========================

		.if eax==PH_ERR
			ret
		.endif

	.elseif eax==TYPE_CEX
		
		; ========================================================
		; This is a console executable, so get its output sub path
		; ========================================================
		
		mov edi, offset SectionList
		mov eax, sizeof FSection
		mul SectionID
		add edi, eax
		invoke GetPrivateProfileString, edi, addr szOut, addr szNULLStr, addr szTmpStr, MAX_PATHSTR_LEN, addr szCurFile

		; ============
		; get its name
		; ============
		
		mov edi, offset SectionList
		mov eax, sizeof FSection
		mul SectionID
		add edi, eax

		; =================================================================
		; concatenate the name and file extension (.EXE) to the path string
		; =================================================================
		
		invoke lstrcat, addr szTmpStr, edi
		invoke lstrcat, addr szTmpStr, addr szExt_EXE

		; ============================================================
		; give some output, so that they know we are linking this file
		; ============================================================

		invoke lstrcpy, pBigBuff, addr szLinking
		invoke lstrcat, pBigBuff, addr szTmpStr
		invoke SendBBuff

		; =========================================================
		; Make the string with the extra switches and the .obj list
		; =========================================================

		invoke MakeOBJSwitchList, SectionID, addr szTmp2Str

		; ====================================================
		; make the commandline from all other strings obtained
		; ====================================================
		
		invoke wsprintf, addr szCmndLine, addr szWSPF_CEX_Str, addr szTmpStr, addr szTmp2Str

		; =================================================
		; Run the linker and get the output from the linker
		; =================================================

		invoke PipeCmnd, addr szCmndLine

		; ==========================
		; sort out the return values
		; ==========================

		.if eax==PH_ERR
			ret
		.endif

	.elseif eax==TYPE_DLL
	
		; ===========================================================
		; This is a dll, so get its def file, saving pointer to stack
		; ===========================================================

		; -------------------------
		; Get file number from file
		; -------------------------
		
		mov edi, offset SectionList
		mov eax, sizeof FSection
		mul SectionID
		add edi, eax
		invoke GetPrivateProfileInt, edi, addr szDef, 0, addr szCurFile

		; ------------------
		; Check for an error
		; ------------------

		.if eax==0
			mov eax, PH_ERR
			ret
		.endif

		; ----------------------------------------------------------------------------------------------
		; convert number to a string by using it (-1) as an index in the OBJList - save pointer on stack
		; ----------------------------------------------------------------------------------------------

		dec eax
		mov ecx, sizeof SFName
		mul ecx
		add eax, offset OBJList
		push eax

		; ===================
		; get its output path
		; ===================
		
		mov edi, offset SectionList
		mov eax, sizeof FSection
		mul SectionID
		add edi, eax
		invoke GetPrivateProfileString, edi, addr szOut, addr szNULLStr, addr szTmpStr, MAX_PATHSTR_LEN, addr szCurFile
		
		; ============
		; get its name
		; ============

		mov edi, offset SectionList
		mov eax, sizeof FSection
		mul SectionID
		add edi, eax
		
		; =============================
		; append to the output sub-path
		; =============================

		invoke lstrcat, addr szTmpStr, edi
		invoke lstrcat, addr szTmpStr, addr szExt_DLL

		; ===========================================
		; output the fact that something is happening
		; ===========================================

		invoke lstrcpy, pBigBuff, addr szLinking
		invoke lstrcat, pBigBuff, addr szTmpStr
		invoke SendBBuff

		; =========================================================
		; Make the string with the extra switches and the .obj list
		; =========================================================

		invoke MakeOBJSwitchList, SectionID, addr szTmp2Str
		
		; ======================================================================================================
		; make the command line by putting all the previous strings together (and get def file out of the stack)
		; ======================================================================================================

		pop edi
		invoke wsprintf, addr szCmndLine, addr szWSPF_DLL_Str, addr szTmpStr, edi, addr szTmp2Str

		; =================================================
		; Run the linker and get the output from the linker
		; =================================================

		invoke PipeCmnd, addr szCmndLine

		; ==========================
		; sort out the return values
		; ==========================

		.if eax==PH_ERR
			ret
		.endif

	.elseif eax==TYPE_LIB
	
		; ===================
		; get lib output path
		; ===================
		
		mov edi, offset SectionList
		mov eax, sizeof FSection
		mul SectionID
		add edi, eax
		invoke GetPrivateProfileString, edi, addr szOut, addr szNULLStr, addr szTmpStr, MAX_PATHSTR_LEN, addr szCurFile

		; ============
		; get its name
		; ============

		mov edi, offset SectionList
		mov eax, sizeof FSection
		mul SectionID
		add edi, eax

		; =============================
		; append to the output sub-path
		; =============================

		invoke lstrcat, addr szTmpStr, edi
		invoke lstrcat, addr szTmpStr, addr szExt_LIB

		; ===========================================
		; output the fact that something is happening
		; ===========================================

		invoke lstrcpy, pBigBuff, addr szLibbing
		invoke lstrcat, pBigBuff, addr szTmpStr
		invoke lstrcat, pBigBuff, addr szRetStr
		invoke SendBBuff

		; =========================================================
		; Make the string with the extra switches and the .obj list
		; =========================================================

		invoke MakeOBJSwitchList, SectionID, addr szTmp2Str

		; ======================================================================================================
		; make the command line by putting all the previous strings together (and get def file out of the stack)
		; ======================================================================================================

		invoke wsprintf, addr szCmndLine, addr szWSPF_LIB_Str, addr szTmpStr, addr szTmp2Str

		; =================================================
		; Run the linker and get the output from the linker
		; =================================================

		invoke PipeCmnd, addr szCmndLine

		; ==========================
		; sort out the return values
		; ==========================

		.if eax==PH_ERR
			ret
		.endif

	.endif
	
	; =================
	; Exit with success
	; =================
	
	mov eax, PH_SUCCESS
	ret
LinkFile ENDP

; ************************************************
; Gets the type of binary for a particular section
; ************************************************

GetBinType PROC SectionID:DWORD
	LOCAL szReturnStr[MAX_LINE_SIZE]:BYTE
	
	; =============================================================
	; Read the TYPE key out of the appropriate section in PInfo.dat
	; =============================================================
	
	mov edi, offset SectionList
	mov eax, sizeof FSection
	mul SectionID
	add edi, eax
	invoke GetPrivateProfileString, edi, addr szType, addr szNULLStr, addr szReturnStr, MAX_LINE_SIZE, addr szCurFile

	; ====================================
	; Check it against each type of binary
	; ====================================
	
	invoke lstrcmp, addr szReturnStr, addr szType_WEX
	.if eax==0
		mov eax, TYPE_WEX
		ret
	.endif

	invoke lstrcmp, addr szReturnStr, addr szType_CEX
	.if eax==0
		mov eax, TYPE_CEX
		ret
	.endif

	invoke lstrcmp, addr szReturnStr, addr szType_DLL
	.if eax==0
		mov eax, TYPE_DLL
		ret
	.endif

	invoke lstrcmp, addr szReturnStr, addr szType_LIB
	.if eax==0
		mov eax, TYPE_LIB
		ret
	.endif

	; ===================
	; Exit - unknown type
	; ===================
	
	mov eax, TYPE_UNKNOWN
	ret
GetBinType ENDP

; ******************************************************************
; Makes the string that is the extra switches and a list of the OBJs
; ******************************************************************

MakeOBJSwitchList PROC SectionID:DWORD, pBuff:DWORD
	LOCAL szOBJNumStr[MAX_LINE_SIZE]:BYTE
	LOCAL CurPOBJ:DWORD
	LOCAL CurNumStr[10]:BYTE
	
	; ==========================
	; Get this Sections OBJ list
	; ==========================

	mov edi, offset SectionList
	mov eax, sizeof FSection
	mul SectionID
	add edi, eax
	invoke GetPrivateProfileString, edi, addr szObj, addr szNULLStr, addr szOBJNumStr, MAX_LINE_SIZE, addr szCurFile

	; =========================================
	; Set the Buffer to being the switch string
	; =========================================

	mov edi, offset SectionList
	mov eax, sizeof FSection
	mul SectionID
	add edi, eax
	invoke GetPrivateProfileString, edi, addr szSwitch, addr szNULLStr, pBuff, MAX_LINE_SIZE, addr szCurFile

	; ==============
	; Setup the loop
	; ==============
	
	lea edi, szOBJNumStr
	mov CurPOBJ, edi

MakeOBJSwitchList_LoopStart:

	; ======================
	; Get the current number
	; ======================

	invoke GetStrToComma, addr CurNumStr, CurPOBJ
	
	; ======================================
	; check this isn't after the last string
	; ======================================
	
	invoke lstrlen, addr CurNumStr
	.if eax==0
		ret
	.endif
	invoke atodw, addr CurNumStr
	.if eax==0
		ret
	.endif
	
	; -----------------------------
	; change the number to an index
	; -----------------------------
	
	dec eax

	; ====================================================================
	; use this to get a pointer to the OBJ name also, save it on the stack
	; ====================================================================

	mov ecx, sizeof SFName
	mul ecx
	mov edi, offset OBJList
	add edi, eax
	push edi

	; ========================================================
	; append to the switch/OBJ buffer, the new OBJ and a space
	; ========================================================

	invoke lstrcat, pBuff, addr szSpcStr
	pop edi
	invoke lstrcat, pBuff, edi
	
	; ===================================
	; Increment OBJ number string pointer
	; ===================================
	
	invoke lstrlen, addr CurNumStr
	add eax, CurPOBJ
	mov cl, [eax]
	cmp cl, ','
	jne @F
	inc eax
@@:
	mov CurPOBJ, eax
	
	; ===============
	; goto loop start
	; ===============
	
	jmp MakeOBJSwitchList_LoopStart
MakeOBJSwitchList ENDP

; ************************************
; Link all of the files in the project
; ************************************

LinkFiles PROC
	LOCAL CurID:DWORD
	
	; =================================
	; Set loop counters to start values
	; =================================
	
	mov eax, 000000002h
	mov CurID, eax

LinkFiles_LoopStart:

	; =====================================================
	; If this section does not exist then exit with success
	; =====================================================

	cmp eax, NumSections
	jne @F
	mov eax, PH_SUCCESS
	ret
@@:

	; =========================
	; Link/Lib the current file
	; =========================

	invoke LinkFile, CurID
	.if eax==PH_ERR
		ret
	.endif

	; ======================
	; increment loop counter
	; ======================

	inc CurID
	mov eax, CurID
	
	; ===================
	; Goto the loop start
	; ===================
	
	jmp LinkFiles_LoopStart
LinkFiles ENDP

; *************************************************************************
; Makes string pointed to by pDest be pSrc up until the first comma in pSrc
; *************************************************************************

GetStrToComma PROC pDest:DWORD, pSrc:DWORD

	; ======================================================================================================
	; Find the length of the Source string & exit with Destination string set to 0 length if Source 0 length
	; ======================================================================================================

	invoke lstrlen, pSrc
	test eax, eax
	jnz @F
	mov edi, pDest
	mov [edi], al
	ret
@@:

	; ===========================================================================
	; setup the "repne scasb" single byte search for a comma in the source string
	; ===========================================================================
	
	mov ecx, eax
	inc ecx
	mov edi, pSrc
	mov al, ','
	repne scasb
	
	; =====================================
	; find out how many chracters in it was
	; =====================================
	
	dec edi
	sub edi, pSrc
	
	; ==============================
	; set up a copy of the substring
	; ==============================
	
	mov ecx, edi
	mov esi, pSrc
	mov edi, pDest
	rep movsb
	
	; =========================================================
	; set the NULL terminator in theDestination string and exit
	; =========================================================
	
	mov [edi], ch
	ret
GetStrToComma ENDP

; *******************************************************************
; Sends all the text pointed to by pBigBuff to RadASM's output window
; *******************************************************************

SendBBuff PROC
	; ================================
	; Check we are not sending nothing
	; ================================
	
	invoke lstrlen, pBigBuff
	test eax, eax
	jnz @F
	ret
@@:

	; ==========================================================================
	; Get rid of all trailing return characters by recursively calling SendBBuff
	; ==========================================================================

	add eax, pBigBuff
	mov cl, [eax-1]
	cmp cl, 0ah
	je @F
	cmp cl, 0dh
	je @F

	; ==================================================
	; no trailing return characters - just send the data
	; ==================================================

	push pBigBuff
	mov eax, [lpPStruct]
	call (ADDINPROCS ptr [eax]).lpTextOut
	ret
@@:

	; =============================
	; Here we do the recursive call
	; =============================

	xor cl, cl
	mov [eax-1], cl
	invoke SendBBuff
	ret
SendBBuff ENDP

; *******************************************
; Procedure for the handling of the PB Dialog
; *******************************************

DlgProc PROC hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL TabStruct:TC_ITEM
	LOCAL NumStr[10]:BYTE
	LOCAL TmpStr[300]:BYTE
	LOCAL Val:DWORD

	mov eax, uMsg
	.if eax==WM_INITDIALOG

		; =========
		; setup tab
		; =========
		
		mov bChangeBack, FALSE

		; ===================
		; Setup the Combo box
		; ===================

		invoke SendDlgItemMessage, hWin, IDC_TYPEBOX, CB_ADDSTRING, 0, addr szCB_WEX
		invoke SendDlgItemMessage, hWin, IDC_TYPEBOX, CB_ADDSTRING, 0, addr szCB_CEX
		invoke SendDlgItemMessage, hWin, IDC_TYPEBOX, CB_ADDSTRING, 0, addr szCB_DLL
		invoke SendDlgItemMessage, hWin, IDC_TYPEBOX, CB_ADDSTRING, 0, addr szCB_LIB
		
		; ===================================
		; see whether theres an existing file
		; ===================================
		
		invoke PInfoExists
		
		.if eax==FALSE
			invoke NewBin, hWin
		.else
		
			; =======
			; load it
			; =======
			
			invoke LoadPInfo, hWin
			.if eax!=FALSE
			
				; ===============
				; Set it to tab 0
				; ===============
				
				invoke SendDlgItemMessage, hWin, IDC_BINTAB, LB_SETCURSEL, 0, 0
			
				; ================
				; Load the new tab
				; ================
				
				invoke LoadBin, hWin
			.endif
		.endif
				
	.elseif eax==WM_COMMAND
		
		; =========================
		; What did the controls do?
		; =========================
	
		mov	eax, wParam
		mov	edx, eax
		shr	edx, 16
		and	eax, 0FFFFh
		.if edx==BN_CLICKED
			
			; =================
			; What was clicked?
			; =================
		
			.if eax==IDC_OK																			; IDC_OK
				
				; ================================
				; Check that the current tab is ok
				; ================================
				
				invoke ParseCurBin, hWin
				.if eax==FALSE
					invoke MessageBox, hWin, addr szBinMustName, addr szPBTag, MB_OK
				.else
				
					; ================
					; Save current Tab
					; ================
					
					invoke SaveCurBin, hWin
					.if eax==FALSE
						invoke MessageBox, hWin, addr szBinAlrdEx, addr szPBTag, MB_OK
					.else
						
						; ===============
						; Do Source Files
						; ===============
						
						invoke CopySFNamesToBuffer, hWin
						invoke AlterSFNames
		
						; ====
						; Save
						; ====
						
						invoke SaveToFile, hWin
						.if eax==FALSE
							mov eax, TRUE
							ret
						.endif

						; ====
						; Exit
						; ====
					
						invoke EndDialog, hWin, 0	
					.endif
				.endif
				
			.elseif eax==IDC_CANCEL																	; IDC_CANCEL
			
				; =========
				; Just exit
				; =========
			
				invoke EndDialog, hWin, 0
				
			.elseif eax==IDC_BROWSE_ADD																; IDC_BROWSE_ADD
				
				; ===================================
				; sort out the OPENFILENAME structure
				; ===================================
				
				invoke lstrlen, addr szOpenTitle
				mov ofn.nMaxFileTitle, eax
				mov ofn.lpstrFile, offset PStr
				mov ofn.lStructSize, sizeof ofn
				m2m ofn.hwndOwner, hWin
				m2m ofn.hInstance, hInstance
				mov ofn.lpstrFilter, offset szFilter
				mov ofn.nMaxFile, MAX_PATHSTR_LEN
				mov ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_NOCHANGEDIR
				mov ofn.lpstrTitle, offset szOpenTitle
				mov ofn.lpstrCustomFilter, NULL
				mov ofn.nFilterIndex, 1
				mov ofn.lpstrInitialDir, NULL
				mov ofn.nFileOffset, 0
				mov ofn.nFileExtension, 0
				mov ofn.lpTemplateName, NULL
				
				; ===============
				; Show the dialog
				; ===============
				
				invoke GetOpenFileName, addr ofn
				.if eax!=0
				
					; =================
					; Get the real path
					; =================
					
					invoke StripCurPath, addr TmpStr, addr PStr
					
					; =====================
					; check for null string
					; =====================
					
					invoke lstrlen, addr TmpStr
					.if eax==0
						invoke MessageBox, hWin, addr szFileMustFrom, addr szPBTag, MB_OK
					.else
					
						; =======================
						; Save it to the text box
						; =======================
					
						invoke SetDlgItemText, hWin, IDC_NEWSFILE, addr TmpStr
					.endif
				.endif

			.elseif eax==IDC_ADDFILE																; IDC_ADDFILE
			
				; ===========================
				; Get the string from the box
				; ===========================

				invoke GetDlgItemText, hWin, IDC_NEWSFILE, addr TmpStr, 299

				; =================================
				; check to see if its already there
				; =================================
				
				invoke SendDlgItemMessage, hWin, IDC_SOURCE_LIST, LB_FINDSTRINGEXACT, 0, addr TmpStr
				.if eax==LB_ERR
					
					; ===================================
					; Check that we're not adding nothing
					; ===================================
					
					invoke lstrlen, addr TmpStr
					.if eax!=0
	
						; ======================
						; Add it to the list box
						; ======================
						
						invoke SendDlgItemMessage, hWin, IDC_SOURCE_LIST, LB_ADDSTRING, 0, addr TmpStr
					.endif
				.endif
				
			.elseif eax==IDC_DELFILE																; IDC_DELFILE
			
				; =======================
				; get the selected string
				; =======================
			
				invoke SendDlgItemMessage, hWin, IDC_SOURCE_LIST, LB_GETCURSEL, 0, 0
				.if eax==LB_ERR
					mov eax, TRUE
					ret
				.endif
				
				; =========
				; delete it
				; =========
				
				invoke SendDlgItemMessage, hWin, IDC_SOURCE_LIST, LB_DELETESTRING, eax, 0
				
			.elseif eax==IDC_ADDFILEBIN																; IDC_ADDFILEBIN
				
				; =================================================================
				; Add a source file to the current binary - get the selected string
				; =================================================================
				
				invoke SendDlgItemMessage, hWin, IDC_SOURCE_LIST, LB_GETCURSEL, 0, 0
				.if eax==LB_ERR
					mov eax, TRUE
					ret
				.endif
				
				; ==========
				; get string
				; ==========

				mov ecx, eax
				invoke SendDlgItemMessage, hWin, IDC_SOURCE_LIST, LB_GETTEXT, ecx, addr TmpStr
				
				; =================================
				; check thats its not already there
				; =================================
				
				invoke SendDlgItemMessage, hWin, IDC_BINLIST, LB_FINDSTRINGEXACT, 0, addr TmpStr
				.if eax==LB_ERR

					; =====================
					; add string to binlist
					; =====================
	
					invoke SendDlgItemMessage, hWin, IDC_BINLIST, LB_ADDSTRING, 0, addr TmpStr
				.endif
				
			.elseif eax==IDC_DELFILEBIN																; IDC_DELFILEBIN
			
				; =======================
				; get the selected string
				; =======================
			
				invoke SendDlgItemMessage, hWin, IDC_BINLIST, LB_GETCURSEL, 0, 0
				.if eax==LB_ERR
					mov eax, TRUE
					ret
				.endif
				
				; =========
				; delete it
				; =========
				
				invoke SendDlgItemMessage, hWin, IDC_BINLIST, LB_DELETESTRING, eax, 0
				
			.elseif eax==IDC_USECURSEL																; IDC_USECURSEL
			
				; ==============================================================
				; Set a def file to the current binary - get the selected string
				; ==============================================================
				
				invoke SendDlgItemMessage, hWin, IDC_SOURCE_LIST, LB_GETCURSEL, 0, 0
				.if eax==LB_ERR
					mov eax, TRUE
					ret
				.endif
				
				; ==========
				; get string
				; ==========

				mov ecx, eax
				invoke SendDlgItemMessage, hWin, IDC_SOURCE_LIST, LB_GETTEXT, ecx, addr TmpStr
				
				; =====================
				; add string to binlist
				; =====================

				invoke SetDlgItemText, hWin, IDC_SELBOX, addr TmpStr
				
			.elseif eax==IDC_ADDBIN																	; IDC_ADDBIN
			
				; ====================
				; Save the current one
				; ====================
			
				invoke SaveCurBin, hWin
				.if eax==FALSE
					invoke MessageBox, hWin, addr szBinAlrdEx, addr szPBTag, MB_OK
				.else
			
					; ===============
					; Add the new tab
					; ===============
				
					invoke NewBin, hWin
				.endif

			.elseif eax==IDC_DELBIN																	; IDC_DELBIN

				; ====================================
				; Check that we do have some tabs left
				; ====================================
				
				invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_GETITEMCOUNT, 0, 0
				.if eax==1
					invoke MessageBox, hWin, addr szMust1Bin, addr szPBTag, MB_OK

					mov eax, TRUE
					ret
				.endif

				; =====================
				; Get the current index
				; =====================
				
				invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_GETCURSEL, 0, 0
				.if eax==LB_ERR
					mov eax, TRUE
					ret
				.endif
				
				mov Val, eax
			
				; ======================
				; Delete the current Tab
				; ======================
				
				invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_DELETEITEM, Val, 0
				
				; ==============================
				; Get the index of the final Tab
				; ==============================
				
				invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_GETITEMCOUNT, 0, 0
				
				.if eax!=Val
				
					; ======================
					; Copy the tab elsewhere
					; ======================
					
					invoke MoveTab, Val, eax
					
					; ==============================
					; Select the new tab and load it
					; ==============================
					
					invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_SETCURSEL, Val, 0

					invoke LoadBin, hWin

				.else
					
					; ================================
					; Select the first tab and load it
					; ================================

					invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_SETCURSEL, 0, 0

					invoke LoadBin, hWin

				.endif
				
				; ===========
				; Rename tabs
				; ===========
				
				invoke RenameTabs, hWin
				
				; =================
				; Redraw the window
				; =================
				
				invoke RedrawWindow, hWin, NULL, NULL, RDW_INVALIDATE

				; ==========================
				; Changed Tab - load new tab
				; ==========================
				
				invoke LoadBin, hWin
			
			.endif
		.endif
	.elseif eax==WM_NOTIFY																			; IDC_BINTAB
		mov eax, lParam
		mov ecx, [eax][NMHDR.code]
		.if ecx==TCN_SELCHANGING
			
			; =======================================
			; Changing Tab - Check & save current tab
			; =======================================
			
			invoke ParseCurBin, hWin
			.if eax==FALSE
				invoke MessageBox, hWin, addr szBinMustName, addr szPBTag, MB_OK

				invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_GETCURSEL, 0, 0
				mov iChangeTo, eax
				mov bChangeBack, TRUE
			.else
				invoke SaveCurBin, hWin
				.if eax==FALSE
					invoke MessageBox, hWin, addr szBinAlrdEx, addr szPBTag, MB_OK
					
					invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_GETCURSEL, 0, 0
					mov iChangeTo, eax
					mov bChangeBack, TRUE
				.endif
			.endif
			
		.elseif ecx==TCN_SELCHANGE
		
			; ===============================
			; Check if we need to change back
			; ===============================
			
			.if bChangeBack==TRUE
				invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_SETCURSEL, iChangeTo, 0
				mov bChangeBack, FALSE
			.else

				; ==========================
				; Changed Tab - load new tab
				; ==========================
				
				invoke LoadBin, hWin
			.endif
			
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog, hWin, 0
	.else
	
		; =========================
		; Exit false - nothing done
		; =========================

		mov eax, FALSE	
        ret
 	.endif
	
	; =======================
	; Exit - we did something
	; =======================
	
	mov eax, TRUE
	ret
DlgProc ENDP

; ************************
; Checks that PInfo exists
; ************************

PInfoExists PROC
	mov edi, [lpDStruct]
	invoke lstrcpy, addr szCurPath, [edi][ADDINDATA.lpProjectPath]
	
	; =======================================================================
	; Check if the last letter in the path is a backslash and if not, add one
	; =======================================================================

	invoke lstrlen, addr szCurPath
	add eax, offset szCurPath
	mov cl, [eax-1]

	.if cl!=5Ch
		mov cx, 005Ch
		mov [eax], cl
		mov [eax+1], ch
	.endif
	
	; =============================
	; Setup the pinfo.dat path/name
	; =============================

	invoke lstrcpy, addr szCurFile, addr szCurPath
	invoke lstrcat, addr szCurFile, addr szProjInfoFile
	
	; =====================
	; Try to open PInfo.dat
	; =====================

	invoke CreateFile, addr szCurFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, NULL, NULL
	.if eax!=INVALID_HANDLE_VALUE
		invoke CloseHandle, eax
		mov eax, TRUE
		ret
	.endif

	mov eax, FALSE
	ret
PInfoExists ENDP

; ***************************************************************
; Strips the project path from the beginning of the passed string
; ***************************************************************

StripCurPath PROC pDest:DWORD, pSrc:DWORD
	
	; ====================
	; Get the current path
	; ====================
	
	mov edi, [lpDStruct]
	invoke lstrcpy, addr szCurPath, [edi][ADDINDATA.lpProjectPath]
	
	; =====================================================================
	; Copy the first path bytes to destination - check enough bytes as well
	; =====================================================================

	; -------------------------
	; Make evrything lower case
	; -------------------------

	invoke lcase, pSrc
	invoke lcase, addr szCurPath

	; -------------
	; check lengths
	; -------------
	
	invoke lstrlen, addr szCurPath
	push eax
	invoke lstrlen, pSrc
	pop ecx
	cmp ecx, eax
	jge StripCurPath_UseFullString

	; -----------------
	; copy byes to dest
	; -----------------
	
	mov edi, pDest
	mov esi, pSrc
	rep movsb
	xor al, al
	mov [edi], al

	; ===============
	; compare strings
	; ===============

	invoke lstrcmp, pDest, addr szCurPath
	test eax, eax
	jnz StripCurPath_UseFullString

	; ===================
	; Copy correct string
	; ===================

	invoke lstrlen, addr szCurPath
	add eax, pSrc
	invoke lstrcpy, pDest, eax
	
	ret
	
	; ===================
	; copy the hole thing
	; ===================
	
StripCurPath_UseFullString:
	
	invoke lstrcpy, pDest, pSrc
	
	ret
StripCurPath ENDP

; *******************************************************
; Save the data from the dialog to the internal variables
; *******************************************************

SaveCurBin PROC hWin:HWND
	LOCAL CurTab:DWORD
	LOCAL pCurTab:DWORD
	LOCAL NumBinFiles:DWORD
	LOCAL RVal:DWORD
	
	; =====================
	; Get current tab index
	; =====================
	
	invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_GETCURSEL, 0, 0
	.if eax==LB_ERR
		mov eax, TRUE
		ret
	.endif
	mov CurTab, eax
	
	; ====================
	; convert to a pointer
	; ====================
	
	mov ecx, sizeof BinStruct
	mul ecx
	add eax, offset BSList
	mov pCurTab, eax
	
	; ============================
	; copy the appropriate strings
	; ============================
	
	add eax, offset BinStruct.szOut
	invoke GetDlgItemText, hWin, IDC_OUTDIR, eax, MAX_LINE_SIZE

	mov eax, pCurTab
	add eax, offset BinStruct.szSwitch
	invoke GetDlgItemText, hWin, IDC_SWITCH, eax, MAX_LINE_SIZE

	mov eax, pCurTab
	add eax, offset BinStruct.szDEF
	invoke GetDlgItemText, hWin, IDC_SELBOX, eax, MAX_LINE_SIZE
	
	mov eax, pCurTab
	add eax, offset BinStruct.szName
	invoke GetDlgItemText, hWin, IDC_BINNAME, eax, MAX_LINE_SIZE
	
	mov eax, pCurTab
	add eax, offset BinStruct.szName
	invoke lcase, eax
	
	; ==========================
	; Check if it already exists
	; ==========================
	
	mov ecx, pCurTab
	add ecx, offset BinStruct.szName
	invoke BinaryExists, ecx, CurTab, hWin
	.if eax==TRUE
		mov RVal, FALSE
	.else
		mov RVal, TRUE
	.endif
	
	; ==================
	; get the type index
	; ==================
	
	invoke SendDlgItemMessage, hWin, IDC_TYPEBOX, CB_GETCURSEL, 0, 0
	mov ecx, pCurTab
	mov [ecx][BinStruct.Type_index], eax
	
	; ======================
	; get the number of objs
	; ======================

	invoke SendDlgItemMessage, hWin, IDC_BINLIST, LB_GETCOUNT, 0, 0
	mov NumBinFiles, eax
	mov ecx, pCurTab
	mov [ecx][BinStruct.nNumObjs], eax
	
	; =======
	; Do loop
	; =======
	
	add ecx, offset BinStruct.OBJ_List
	mov pCurTab, ecx
	xor ecx, ecx
SaveCurBin_OBJLoop:

	; ==================
	; check for num left
	; ==================
	
	cmp ecx, NumBinFiles
	jne @F
	mov eax, RVal
	ret
@@:

	; =====================
	; save the current text
	; =====================

	push ecx
	invoke SendDlgItemMessage, hWin, IDC_BINLIST, LB_GETTEXT, ecx, pCurTab
	inc eax
	add pCurTab, eax
	pop ecx
	
	; ===========================
	; increment for loop and jump
	; ===========================
	
	inc ecx
	jmp SaveCurBin_OBJLoop
SaveCurBin ENDP

; ********************************************************
; Loads the data to the dialog from the internal variables
; ********************************************************

LoadBin PROC hWin:HWND
	LOCAL TabIndex:DWORD
	LOCAL pCurTab:DWORD
	LOCAL NumBinFiles:DWORD

	; ===============
	; Set the new tab
	; ===============

	invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_GETCURSEL, 0, 0
	.if eax==LB_ERR
		ret
	.endif
	mov TabIndex, eax

	; ====================
	; convert to a pointer
	; ====================
	
	mov ecx, sizeof BinStruct
	mul ecx
	add eax, offset BSList
	mov pCurTab, eax
	
	; ============================
	; copy the appropriate strings
	; ============================
	
	add eax, offset BinStruct.szOut
	invoke SetDlgItemText, hWin, IDC_OUTDIR, eax

	mov eax, pCurTab
	add eax, offset BinStruct.szSwitch
	invoke SetDlgItemText, hWin, IDC_SWITCH, eax

	mov eax, pCurTab
	add eax, offset BinStruct.szName
	invoke SetDlgItemText, hWin, IDC_BINNAME, eax
	
	mov eax, pCurTab
	add eax, offset BinStruct.szDEF
	invoke SetDlgItemText, hWin, IDC_SELBOX, eax
	
	; ==================
	; get the type index
	; ==================
	
	mov eax, pCurTab
	invoke SendDlgItemMessage, hWin, IDC_TYPEBOX, CB_SETCURSEL, [eax][BinStruct.Type_index], 0
	
	; ======================
	; Delete current entries
	; ======================
	
	invoke DelAllInBLBox, hWin

	; ======================
	; get the number of objs
	; ======================

	mov ecx, pCurTab
	mov eax, [ecx][BinStruct.nNumObjs]
	mov NumBinFiles, eax
	
	; =======
	; Do loop
	; =======
	
	add ecx, offset BinStruct.OBJ_List
	mov pCurTab, ecx
	xor ecx, ecx
LoadBin_OBJLoop:

	; ==================
	; check for num left
	; ==================
	
	cmp ecx, NumBinFiles
	jne @F
	ret
@@:

	; =====================
	; save the current text
	; =====================

	push ecx
	invoke SendDlgItemMessage, hWin, IDC_BINLIST, LB_ADDSTRING, 0, pCurTab

	; ===========================
	; increment for loop and jump
	; ===========================

	invoke lstrlen, pCurTab
	inc eax
	add pCurTab, eax
	
	pop ecx
	inc ecx
	jmp LoadBin_OBJLoop
LoadBin ENDP

; ***************
; Makes a new tab
; ***************

NewBin PROC hWin:HWND
	LOCAL NewIndex:DWORD
	LOCAL NumStr[10]:BYTE
	LOCAL TmpStr[50]:BYTE
	LOCAL TabStruct:TC_ITEM

	; =====================
	; Get the current count
	; =====================

	invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_GETITEMCOUNT, 0, 0
	mov NewIndex, eax
	
	; =============
	; Setup the tab
	; =============
	
	invoke udwtoa, NewIndex, addr NumStr
	invoke lstrcpy, addr TmpStr, addr szBinary
	invoke lstrcat, addr TmpStr, addr NumStr
	
	lea eax, TmpStr
	mov TabStruct.pszText, eax
	mov TabStruct.imask, TCIF_TEXT	
	mov TabStruct.cchTextMax, 1
	mov TabStruct.iImage, -1
	mov TabStruct.lpReserved1, 0
	mov TabStruct.lpReserved2, 0
	mov TabStruct.lParam, 0
	
	invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_INSERTITEM, NewIndex, addr TabStruct
	invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_SETCURSEL, NewIndex, 0

	; ============
	; Set controls
	; ============
	
	invoke SendDlgItemMessage, hWin, IDC_TYPEBOX, CB_SETCURSEL, 0, 0
	invoke SetDlgItemText, hWin, IDC_OUTDIR, addr szNULLStr
	invoke SetDlgItemText, hWin, IDC_SWITCH, addr szNULLStr
	invoke SetDlgItemText, hWin, IDC_BINNAME, addr szNULLStr
	invoke SetDlgItemText, hWin, IDC_SELBOX, addr szNULLStr
	invoke SetDlgItemText, hWin, IDC_SELBOX, addr szNULLStr
	
	invoke DelAllInBLBox, hWin
	
	; ====
	; Exit
	; ====
	
	ret
NewBin ENDP

; ***********************************
; Delete everything in the BinListBox
; ***********************************

DelAllInBLBox PROC hWin:HWND

	; ============================
	; Get the number to get rid of
	; ============================

	invoke SendDlgItemMessage, hWin, IDC_BINLIST, LB_GETCOUNT, 0, 0
	
DelAllInBLBox_Loop:

	; ==============
	; check for last
	; ==============

	test eax, eax
	jnz @F
	ret
@@:
	
	; ==========================
	; Delete this one (save eax)
	; ==========================

	push eax
	dec eax
	invoke SendDlgItemMessage, hWin, IDC_BINLIST, LB_DELETESTRING, eax, 0
	pop eax
	
	; =========================
	; decrement for loop & jump
	; =========================
	
	dec eax
	jmp DelAllInBLBox_Loop
DelAllInBLBox ENDP

; ***************************************
; Copies the data from one tab to another
; ***************************************

MoveTab PROC To:DWORD, From:DWORD

	; ========================
	; get pointers to each tab
	; ========================

	mov ecx, sizeof BinStruct

	mov eax, From
	mul ecx
	add eax, offset BSList
	mov esi, eax
	
	mov eax, To
	mul ecx
	add eax, offset BSList
	mov edi, eax
	
	; ====
	; copy
	; ====
	
	rep movsb
	
	; ====
	; Exit
	; ====
	
	ret
MoveTab ENDP

; ***********************************************
; Renames all the tabs after one has been deleted
; ***********************************************

RenameTabs PROC hWin:HWND
	LOCAL ICount:DWORD
	LOCAL NumStr[10]:BYTE
	LOCAL TmpStr[50]:BYTE
	LOCAL TabStruct:TC_ITEM

	; ==============
	; Get item count
	; ==============

	invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_GETITEMCOUNT, 0, 0
	dec eax
	mov ecx, eax

ICount_Loop:

	; =====================================================================
	; Rename each of the by making the new string and copying it to the tab
	; =====================================================================
	
	push ecx
	invoke udwtoa, ecx, addr NumStr
	invoke lstrcpy, addr TmpStr, addr szBinary
	invoke lstrcat, addr TmpStr, addr NumStr
	
	lea eax, TmpStr
	mov TabStruct.pszText, eax
	mov TabStruct.imask, TCIF_TEXT
	mov TabStruct.cchTextMax, 1
	mov TabStruct.iImage, -1
	mov TabStruct.lpReserved1, 0
	mov TabStruct.lpReserved2, 0
	mov TabStruct.lParam, 0

	pop ecx
	push ecx
	
	invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_SETITEM, ecx, addr TabStruct

	; ==================
	; check for last tab
	; ==================

	pop ecx	
	test ecx, ecx
	jnz @F
	ret
@@:

	; ==========================
	; sort out the loop and jump
	; ==========================

	dec ecx
	jmp ICount_Loop
RenameTabs ENDP

; ************************************************
; Loads all the data from PInfo.dat for the dialog
; ************************************************

LoadPInfo PROC hWin:HWND
	LOCAL pBin:DWORD
	LOCAL Count:DWORD

	; ===========================
	; First, load stuff to memory
	; ===========================

	invoke GetSections
	.if NumSections<=2
		invoke MessageBox, hWin, addr szPInfoNoData, addr szPBTag, MB_OK

		mov eax, FALSE
		ret
	.endif
	
	; ========================================
	; read the source file list from pinfo.dat
	; ========================================
	
	invoke GetSFiles
	.if NumFiles==0
		invoke MessageBox, hWin, addr szPInfoNoData, addr szPBTag, MB_OK

		mov eax, FALSE
		ret
	.endif
	
	; ========
	; Do paths
	; ========

	invoke DoDlgPaths, hWin

	; ===============================
	; Load the Files into the listbox
	; ===============================

	invoke LoadFilesLB, hWin

	; ================================================
	; For each section, read in the structure properly
	; ================================================

	mov ecx, 000000002h
	mov Count, ecx
	mov edi, offset BSList
	mov pBin, edi
	
LoadPInfo_SLoop:	
	
	cmp ecx, NumSections
	jne @F
	mov eax, TRUE
	ret
@@:
	
	; ===========
	; Do this one
	; ===========
	
	invoke LoadBinPInfo, hWin, pBin, Count
	
	; ============
	; set for loop
	; ============
	
	inc Count
	mov ecx, Count
	add pBin, sizeof BinStruct
	mov edi, pBin
	
	; ====
	; Jump
	; ====
	
	jmp LoadPInfo_SLoop
LoadPInfo ENDP

; ***********************
; Loads a specific Binary
; ***********************

LoadBinPInfo PROC hWin:HWND, pBin:DWORD, Count:DWORD

	; ==============
	; make a new tab
	; ==============

	invoke NewBin, hWin

	; =========
	; Save name
	; =========
	
	mov esi, offset SectionList
	mov eax, sizeof FSection
	mul Count
	add esi, eax
	mov edi, pBin
	add edi, offset BinStruct.szName

	invoke lstrcpy, edi, esi
	
	; =============
	; Save switches
	; =============

	mov edi, pBin
	mov esi, edi
	add edi, offset BinStruct.szName
	add esi, offset BinStruct.szSwitch
	
	invoke GetPrivateProfileString, edi, addr szObj, addr szNULLStr, esi, MAX_LINE_SIZE, addr szCurFile
	
	; =============
	; Save switches
	; =============

	mov edi, pBin
	mov esi, edi
	add edi, offset BinStruct.szName
	add esi, offset BinStruct.szSwitch
	
	invoke GetPrivateProfileString, edi, addr szSwitch, addr szNULLStr, esi, MAX_LINE_SIZE, addr szCurFile
	
	; ===========
	; Get def num
	; ===========
	
	mov edi, pBin
	add edi, offset BinStruct.szName

	invoke GetPrivateProfileInt, edi, addr szDef, 0, addr szCurFile
	
	; =============
	; Save def name
	; =============

	mov edi, pBin
	add edi, offset BinStruct.szDEF
	
	dec eax
	
	invoke CopySFName, eax, edi
	
	; ====================
	; save the output path
	; ====================

	mov edi, pBin
	mov esi, edi
	add edi, offset BinStruct.szName
	add esi, offset BinStruct.szOut
	
	invoke GetPrivateProfileString, edi, addr szOut, addr szNULLStr, esi, MAX_LINE_SIZE, addr szCurFile
	
	; =======
	; do objs
	; =======
	
	invoke GetOBJSFromFile, hWin, Count
	
	; ====================
	; get the section type
	; ====================
	
	invoke GetBinType, Count
	
	mov edi, pBin
	mov [edi][BinStruct.Type_index], eax
	
	ret
LoadBinPInfo ENDP

; ********************************************
; Loads all the source files into the list box
; ********************************************

LoadFilesLB PROC hWin:HWND

	; =======
	; Do loop
	; =======

	xor ecx, ecx

LoadFilesLB_Loop:

	cmp ecx, NumFiles
	jne @F
	ret
@@:

	; ================
	; copy current one
	; ================
	
	push ecx
	
	mov eax, sizeof SFName
	mul ecx
	add eax, offset SFNameList

	invoke SendDlgItemMessage, hWin, IDC_SOURCE_LIST, LB_ADDSTRING, 0, eax
	
	; =======
	; ++ loop
	; =======
	
	pop ecx
	inc ecx
	jmp LoadFilesLB_Loop
LoadFilesLB ENDP

; *****************************************************
; Copies the required Source File name to a text buffer
; *****************************************************

CopySFName PROC SFNum:DWORD, szDest:DWORD

	; ==================
	; Get SFName pointer
	; ==================

	mov eax, sizeof SFName
	mul SFNum
	add eax, offset SFNameList

	; ====
	; Copy
	; ====

	invoke lstrcpy, szDest, eax
	
	; ====
	; Exit
	; ====
	
	ret
CopySFName ENDP

; ***************************************
; Gets the OBJ into memory for the dialog
; ***************************************

GetOBJSFromFile PROC hWin:HWND, SectionID:DWORD
	LOCAL szOBJNumStr[MAX_LINE_SIZE]:BYTE
	LOCAL CurPOBJ:DWORD
	LOCAL pDest:DWORD
	LOCAL pNum:DWORD
	LOCAL CurNumStr[10]:BYTE
	
	; ==========================
	; Get this Sections OBJ list
	; ==========================

	mov edi, offset SectionList
	mov eax, sizeof FSection
	mul SectionID
	add edi, eax
	invoke GetPrivateProfileString, edi, addr szObj, addr szNULLStr, addr szOBJNumStr, MAX_LINE_SIZE, addr szCurFile

	; ==============
	; Setup the loop
	; ==============
	
	lea edi, szOBJNumStr
	mov CurPOBJ, edi
	
	mov eax, sizeof BinStruct
	mov ecx, SectionID
	sub ecx, 000000002h
	mul ecx
	add eax, offset BSList.OBJ_List
	mov pDest, eax
	
	mov eax, sizeof BinStruct
	mov ecx, SectionID
	sub ecx, 000000002h
	mul ecx
	add eax, offset BSList.nNumObjs
	mov pNum, eax
	xor ecx, ecx
	mov [eax], ecx

GetOBJSFromFile_LoopStart:

	; ======================
	; Get the current number
	; ======================

	invoke GetStrToComma, addr CurNumStr, CurPOBJ
	
	; ======================================
	; check this isn't after the last string
	; ======================================
	
	invoke lstrlen, addr CurNumStr
	.if eax==0
		ret
	.endif
	invoke atodw, addr CurNumStr
	.if eax==0
		ret
	.endif
	
	; -----------------------------
	; change the number to an index
	; -----------------------------
	
	dec eax
	mov esi, eax

	; ==================
	; Save to the buffer
	; ==================

	invoke CopySFName, esi, pDest
	
	; ===================================
	; Increment OBJ number string pointer
	; ===================================
	
	invoke lstrlen, addr CurNumStr
	add eax, CurPOBJ
	mov cl, [eax]
	cmp cl, ','
	jne @F
	inc eax
@@:
	mov CurPOBJ, eax
	
	; ======================
	; Increment dest pointer
	; ======================

	invoke lstrlen, pDest
	inc eax
	add pDest, eax

	mov eax, pDest
	xor cl, cl
	mov [eax+1], cl
	
	mov eax, pNum
	inc dword ptr [eax]
	
	; ===============
	; goto loop start
	; ===============
	
	jmp GetOBJSFromFile_LoopStart
GetOBJSFromFile ENDP

; ******************************************************************************************************************
; Sets the build path in the dialog and alters all names to include the source path (as long is its not a full path)
; ******************************************************************************************************************

DoDlgPaths PROC hWin:HWND
	LOCAL szTmpStr[MAX_LINE_SIZE]:BYTE
	LOCAL pOtherBit:DWORD
	LOCAL Count:DWORD

	; ==================
	; Get the build path
	; ==================

	invoke GetPrivateProfileString, addr szFolders, addr szBuild, addr szNULLStr, addr szTmpStr, MAX_LINE_SIZE, addr szCurFile
	
	; ======================
	; Set it in the edit box
	; ======================

	invoke SetDlgItemText, hWin, IDC_BUILDDIR, addr szTmpStr
	
	; ===================
	; Get the source path
	; ===================

	invoke GetPrivateProfileString, addr szFolders, addr szSource, addr szNULLStr, addr szTmpStr, MAX_LINE_SIZE, addr szCurFile
	
	; ========================================================================================================
	; do a loop through each SF and prepend the source path to their strings after checking if its a full path
	; ========================================================================================================

	invoke lstrlen, addr szTmpStr
	lea ecx, szTmpStr
	add eax, ecx
	mov pOtherBit, eax
	
	xor eax, eax
	mov Count, eax

DoDlgPaths_Loop:

	cmp eax, NumFiles
	jne @F
	ret
@@:

	; =========================
	; Copy the current bit here
	; =========================
	
	invoke CopySFName, Count, pOtherBit
	
	; ===================
	; check for full path
	; ===================
	
	invoke IsPathFull, pOtherBit
	.if eax==TRUE

		; ==================
		; copy only the path
		; ==================
		
		mov eax, sizeof SFName
		mul Count
		add eax, offset SFNameList
		mov ecx, eax
	
		invoke lstrcpy, ecx, pOtherBit
	.else

		; ==============
		; copy this back
		; ==============
	
		mov eax, sizeof SFName
		mul Count
		add eax, offset SFNameList
		mov ecx, eax
	
		invoke lstrcpy, ecx, addr szTmpStr
	.endif
	
	; ======
	; repeat
	; ======
	
	inc Count
	mov eax, Count
	
	jmp DoDlgPaths_Loop
DoDlgPaths ENDP

; **************************************************
; Is the passed string a full path or just relative?
; **************************************************

IsPathFull PROC pPath:DWORD
	
	; =============================
	; Check second char for a colon
	; =============================

	mov eax, FALSE
	mov edx, pPath
	inc edx
	cmp byte ptr [edx], ':'
	jne @F
	mov eax, TRUE
@@:

	ret
IsPathFull ENDP

; ******************************************************************
; Finds the number of bytes at the start of 2 strings that are equal
; ******************************************************************

NumBEqual PROC pStr1:DWORD, pStr2:DWORD

	; ===============================
	; compare which string is shorter
	; ===============================
	
	invoke lstrlen, pStr1
	push eax
	invoke lstrlen, pStr2
	pop ecx
	
	; ==========
	; setup loop
	; ==========
	
	cmp ecx, eax
	jle @F
	mov ecx, eax
@@:
	xor eax, eax
	mov edi, pStr1
	mov esi, pStr2

@@:
	; ===============
	; compare counter
	; ===============

	test ecx, ecx
	jz @F
	
	; =============
	; compare chars
	; =============
	
	mov dl, [edi]
	cmp dl, [esi]
	jne @F

	; ==================
	; increment for loop
	; ==================

	inc esi
	inc edi
	inc eax
	dec ecx
	
	jmp @B
	
@@:
	; ====
	; Exit
	; ====

	ret
NumBEqual ENDP

; ************************************************************
; Copies all strings from the source box to the SF Name Buffer
; ************************************************************

CopySFNamesToBuffer PROC hWin:HWND
	LOCAL CurSF:DWORD
	LOCAL CurPN:DWORD
	
	; ==============================
	; Get item count (of file names)
	; ==============================
	
	invoke SendDlgItemMessage, hWin, IDC_SOURCE_LIST, LB_GETCOUNT, 0, 0
	mov NumFiles, eax
	
	; =========
	; Init Loop
	; =========
	
	xor eax, eax
	mov CurSF, eax
	
	m2m CurPN, offset SFNameList

CopySFNamesToBuffer_Loop:

	; =====================
	; copy the current path
	; =====================
	
	invoke SendDlgItemMessage, hWin, IDC_SOURCE_LIST, LB_GETTEXT, CurSF, CurPN
	
	; ====
	; Loop
	; ====

	add CurPN, sizeof SFName
	inc CurSF
	
	mov eax, NumFiles
	cmp eax, CurSF
	jne CopySFNamesToBuffer_Loop
	
	ret
CopySFNamesToBuffer ENDP

; **********************************************************************************************************
; Gets the index of the next source file (including the one whose index was passed) which is not a full path
; **********************************************************************************************************

GetNextSFNotFullPath PROC dwIndex:DWORD
	LOCAL CurPN:DWORD

	; ==========
	; Setup Loop
	; ==========

	mov eax, sizeof SFName
	mul dwIndex
	add eax, offset SFNameList
	mov CurPN, eax

GetNextSFNotFullPath_Loop:

	; ======================
	; check the current path
	; ======================
	
	invoke IsPathFull, CurPN
	.if eax==FALSE

		; =================
		; return this index
		; =================
		
		mov eax, dwIndex
		ret
	.endif
	
	; =====================
	; setup next one & jump
	; =====================
	
	inc dwIndex
	add CurPN, sizeof SFName
	
	mov eax, dwIndex
	cmp eax, NumFiles
	jne GetNextSFNotFullPath_Loop
	
	; ==================
	; return -1 and exit
	; ==================
	
	mov eax, -1
	ret
GetNextSFNotFullPath ENDP

; *****************************************************************************
; Gets the common root for all non-full path file names in the source file list
; *****************************************************************************

GetSFNameRoot PROC pBuf:DWORD
	LOCAL SFIndex1:DWORD
	LOCAL SFIndex2:DWORD
	LOCAL SFPoint1:DWORD
	LOCAL SFPoint2:DWORD
	LOCAL MinVal:DWORD

	; ====
	; Init
	; ====
	
	mov MinVal, 7FFFFFFFh

	; ==================
	; Get the first file
	; ==================

	invoke GetNextSFNotFullPath, 0
	.if eax==-1
	
		; ---------------------------
		; Exit - there are no strings
		; ---------------------------
	
		mov eax, pBuf
		xor dl, dl
		mov [eax], dl
		ret
	.endif
	mov SFIndex1, eax
	
	; ===================
	; Get the second file
	; ===================

	mov eax, SFIndex1
	inc eax	
	invoke GetNextSFNotFullPath, eax
	.if eax==-1
	
		; -------------------------------
		; Exit - there is only one string
		; -------------------------------

		mov eax, pBuf
		xor dl, dl
		mov [eax], dl
		ret
	.endif
	mov SFIndex2, eax

	; ==========================================================================
	; loop through all until either no common string is found, or all files used
	; ==========================================================================
	
	; =================
	; make the pointers
	; =================
	
	mov eax, sizeof SFName
	mul SFIndex1
	add eax, offset SFNameList
	mov SFPoint1, eax

GetSFNameRoot_Loop:

	mov eax, sizeof SFName
	mul SFIndex2
	add eax, offset SFNameList
	mov SFPoint2, eax
	
	; =======================
	; Get the num bytes equal
	; =======================
	
	invoke NumBEqual, SFPoint1, SFPoint2
	.if eax==0
	
		; --------------------------------
		; Exit - there is no common string
		; --------------------------------
	
		mov eax, pBuf
		xor dl, dl
		mov [eax], dl
		ret
	.endif

	; ===================
	; Set the smaller one
	; ===================

	cmp eax, MinVal
	jge @F
	mov MinVal, eax
@@:

	; =============================
	; Check if this is the last one
	; =============================
	
	mov eax, NumFiles
	dec eax
	cmp eax, SFIndex2
	je GetSFNameRoot_Copy
	
	; ==================
	; Setup the next one
	; ==================
	
	m2m SFIndex1, SFIndex2
	m2m SFPoint1, SFPoint2
	
	mov eax, SFIndex1
	inc eax
	invoke GetNextSFNotFullPath, eax
	cmp eax, -1
	je GetSFNameRoot_Copy
	mov SFIndex2, eax
	
	; ====
	; Jump
	; ====
	
	jmp GetSFNameRoot_Loop

GetSFNameRoot_Copy:

	; =========================================
	; Copy the first MinVal chars to the buffer
	; =========================================
	
	mov edi, pBuf
	mov ecx, MinVal
	
	test ecx, ecx
	jnz @F
	mov byte ptr [edi], 00h
	ret
@@:
	
	mov esi, SFPoint1
	rep movsb
	
	inc edi
	mov byte ptr [edi], 00h
	
GetSFNameRoot_BSLoop:

	; =========================================
	; Now find the last backslash in the string
	; =========================================
	
	dec edi
	cmp edi, pBuf
	je @F
	
	mov al, [edi]
	cmp al, '\'
	jne GetSFNameRoot_BSLoop
	inc edi
@@:

	mov byte ptr [edi], 00h
	ret
GetSFNameRoot ENDP

; ************************************************************
; Alter the names of all of the names which are not full paths
; ************************************************************

AlterSFNames PROC
	LOCAL CurSF:DWORD
	LOCAL CurPN:DWORD
	LOCAL StrLenVar:DWORD
	
	; ======================
	; Get root string length
	; ======================
	
	invoke GetSFNameRoot, addr szSourcePath

	invoke lstrlen, addr szSourcePath
	mov StrLenVar, eax
	
	; =====================
	; Check for NULL string
	; =====================

	test eax, eax
	jnz @F
	
	; ----------------
	; no chenge needed
	; ----------------
	
	ret
	
@@:
	; =========
	; Init Loop
	; =========
	
	xor eax, eax
	mov CurSF, eax
	
	m2m CurPN, offset SFNameList

CopySFNamesToBuffer_Loop:

	; =========================
	; is the current path full?
	; =========================
	
	invoke IsPathFull, CurPN
	.if eax==FALSE
		
		; =========================
		; Get rid of the sub string
		; =========================
		
		invoke lstrlen, CurPN
		sub eax, StrLenVar
		mov ecx, eax
		inc ecx
		mov esi, CurPN
		mov edi, CurPN
		add esi, StrLenVar
		rep movsb
	.endif
	
	; ====
	; Loop
	; ====

	add CurPN, sizeof SFName
	inc CurSF
	
	mov eax, NumFiles
	cmp eax, CurSF
	jne CopySFNamesToBuffer_Loop
	
	ret
AlterSFNames ENDP

; ****************************************************************
; Copies the number in string form of a string's index to a buffer
; ****************************************************************

StringIndexToStr PROC pBuf:DWORD, hWin:HWND, pString:DWORD
	LOCAL nbw:DWORD
	
	; =====================
	; Check for NULL string
	; =====================
	
	mov eax, pString
	cmp byte ptr [eax], 00h
	jne @F
	mov eax, TRUE
	ret
@@:
	
	; ====================
	; Get the string index
	; ====================
	
	invoke SendDlgItemMessage, hWin, IDC_SOURCE_LIST, LB_FINDSTRINGEXACT, 0, pString
	.if eax==LB_ERR
		invoke MessageBox, hWin, addr szSFNotFound, addr szPBTag, MB_OK
	
		mov eax, FALSE
		ret
	.endif
	inc eax
	
	; =======================
	; Make the index a string
	; =======================
	
	invoke udwtoa, eax, pBuf
	
	; ====
	; Exit
	; ====
	
	mov eax, TRUE
	ret
StringIndexToStr ENDP

; **************************************************************************
; Converts an BIN making index to string list of indexes for the OBJs needed
; **************************************************************************

OBJListToStr PROC pBuf:DWORD, hWin:HWND, OBJIndex:DWORD
	LOCAL CurPB:DWORD
	LOCAL CurPO:DWORD
	LOCAL MaxOBJ:DWORD
	LOCAL CurOBJ:DWORD
	







	; =============================
	; Setup the start of the buffer
	; =============================
	
	invoke lstrcpy, pBuf, addr szObj
	invoke lstrcat, pBuf, addr szEquals
	
	; ====================================
	; Get pointer to the end of the string
	; ====================================
	
	m2m CurPB, pBuf
	add CurPB, 4
	
	; ====================================
	; do the same for the first OBJ string
	; ====================================

	mov eax, sizeof BinStruct

	mul OBJIndex
	add eax, offset BSList
	
	m2m MaxOBJ, [eax][BinStruct.nNumObjs]
	add eax, offset BinStruct.OBJ_List
	mov CurPO, eax
	
	; ==========
	; setup loop
	; ==========
	
	mov CurOBJ, 00000000h
	
OBJListToStr_Loop:

	; =================
	; Add current index
	; =================
	
	invoke StringIndexToStr, CurPB, hWin, CurPO
	.if eax==FALSE
		ret
	.endif

	; ===============
	; set new pointer
	; ===============

	invoke lstrlen, CurPO
	inc eax
	add CurPO, eax
	
	; ============================================
	; Setup for next loop and check exit condition
	; ============================================
	
	inc CurOBJ
	mov eax, CurOBJ
	cmp eax, MaxOBJ
	jne @F
	
	mov eax, TRUE
	ret
	
@@:
	; ===========
	; add a comma
	; ===========

	invoke lstrcat, pBuf, addr szComma

	invoke lstrlen, CurPB
	add CurPB, eax
	
	; ====
	; jump
	; ====
	
	jmp OBJListToStr_Loop
OBJListToStr ENDP

; ****************************
; Create an entry for a Binary
; ****************************

BinToStr PROC pBuf:DWORD, hWin:HWND, OBJIndex:DWORD
	LOCAL pBinStruct:DWORD
	
	; ===========
	; set pointer
	; ===========
	
	mov eax, sizeof BinStruct
	mul OBJIndex
	add eax, offset BSList
	mov pBinStruct, eax
	
	; ========
	; Make "["
	; ========
	
	mov edi, pBuf
	mov byte ptr [edi], '['
	inc edi
	
	; =============
	; copy the name
	; =============
	
	add eax, offset BinStruct.szName
	invoke lstrcpy, edi, eax
	
	; =============
	; Add the "]\n"
	; =============
	
	invoke lstrlen, pBuf
	add eax, pBuf
	
	mov byte ptr [eax], ']'
	mov byte ptr [eax+1], 0Dh
	mov byte ptr [eax+2], 0Ah
	
	add eax, 3
	mov pBuf, eax
	
	; ==============
	; Now do the OBJ
	; ==============
	
	invoke OBJListToStr, pBuf, hWin, OBJIndex
	.if eax==FALSE
		ret
	.endif
	invoke lstrcat, pBuf, addr szRetStr
	
	invoke lstrlen, pBuf
	add pBuf, eax
	
	; ===========
	; do the Type
	; ===========
	
	mov ecx, pBinStruct
	invoke TypeToStr, pBuf, [ecx][BinStruct.Type_index]
	invoke lstrcat, pBuf, addr szRetStr
	
	; ==========
	; Do the def
	; ==========
	
	invoke lstrcat, pBuf, addr szDef
	invoke lstrcat, pBuf, addr szEquals

	invoke lstrlen, pBuf
	add pBuf, eax

	mov ecx, pBinStruct
	add ecx, offset BinStruct.szDEF
	invoke StringIndexToStr, pBuf, hWin, ecx
	.if eax==FALSE
		ret
	.endif
	invoke lstrcat, pBuf, addr szRetStr
	
	; =========
	; Do output
	; =========

	invoke lstrcat, pBuf, addr szOut
	invoke lstrcat, pBuf, addr szEquals
	mov ecx, pBinStruct
	add ecx, offset BinStruct.szOut
	invoke lstrcat, pBuf, ecx
	invoke lstrcat, pBuf, addr szRetStr
	
	; =========
	; Do switch
	; =========

	invoke lstrcat, pBuf, addr szSwitch
	invoke lstrcat, pBuf, addr szEquals
	mov ecx, pBinStruct
	add ecx, offset BinStruct.szSwitch
	invoke lstrcat, pBuf, ecx
	invoke lstrcat, pBuf, addr szRetStr
	
	mov eax, TRUE
	ret
BinToStr ENDP

; *********************************************
; converts a DWORD Binary type code to a string
; *********************************************

TypeToStr PROC pBuf:DWORD, FType:DWORD
	
	; ============
	; Copy "TYPE="
	; ============

	invoke lstrcpy, pBuf, addr szType
	invoke lstrcat, pBuf, addr szEquals
	
	; ====================
	; choose type and copy
	; ====================

	mov eax, FType
	
	.if eax==TYPE_WEX
		invoke lstrcat, pBuf, addr szType_WEX
	.elseif eax==TYPE_CEX
		invoke lstrcat, pBuf, addr szType_CEX
	.elseif eax==TYPE_DLL
		invoke lstrcat, pBuf, addr szType_DLL
	.elseif eax==TYPE_LIB
		invoke lstrcat, pBuf, addr szType_LIB
	.endif
	
	; ====
	; Exit
	; ====
	
	ret
TypeToStr ENDP

; **********************************************
; Appends the list of source files to the buffer
; **********************************************

AppendSFiles PROC pBuf:DWORD
	LOCAL CurF:DWORD
	LOCAL CurP:DWORD
	
	; ===============
	; Check for files
	; ===============
	
	test NumFiles, 0FFFFFFFFh
	jnz @F
	ret
@@:
	
	; ==========
	; Setup loop
	; ==========
	
	mov CurP, offset SFNameList
	mov CurF, 00000000h
	
	invoke lstrlen, pBuf
	add pBuf, eax
	
AppendSFiles_Loop:

	; =================
	; Get current index
	; =================
	
	mov ecx, CurF
	inc ecx
	
	; ================
	; Make it a string
	; ================
	
	invoke udwtoa, ecx, pBuf
	
	; ==========
	; Add an "="
	; ==========
	
	invoke lstrcat, pBuf, addr szEquals
	
	; =================
	; Append the string
	; =================
	
	invoke lstrcat, pBuf, CurP
	invoke lstrcat, pBuf, addr szRetStr
	
	; ===============
	; Setup next loop
	; ===============
	
	inc CurF
	add CurP, sizeof SFName
	
	invoke lstrlen, pBuf
	add pBuf, eax
	
	; ====================
	; check end conditions
	; ====================
	
	mov eax, CurF
	cmp eax, NumFiles
	jne AppendSFiles_Loop
	
	; ====
	; Exit
	; ====
	
	ret
AppendSFiles ENDP

; *************************
; Save the Current settings
; *************************

SaveToFile PROC hWin:HWND
	LOCAL hFile:HANDLE
	LOCAL szTmpStr[MAX_BUFF_SIZE]:BYTE
	LOCAL nUseless:DWORD
	LOCAL CurOBJ:DWORD
	LOCAL CurStrP:DWORD
	
	; ==============
	; Get Build Path
	; ==============
	
	invoke GetDlgItemText, hWin, IDC_BUILDDIR, addr szBuildPath, MAX_BUFF_SIZE
	
	; ==============
	; Do "[folders]"
	; ==============

	; [folders]
	invoke lstrcpy, addr szTmpStr, addr szOpenSqBrac
	invoke lstrcat, addr szTmpStr, addr szFolders
	invoke lstrcat, addr szTmpStr, addr szCloseSqBrac
	invoke lstrcat, addr szTmpStr, addr szRetStr
	
	; BUILD=...
	invoke lstrcat, addr szTmpStr, addr szBuild
	invoke lstrcat, addr szTmpStr, addr szEquals
	invoke lstrcat, addr szTmpStr, addr szBuildPath
	invoke lstrcat, addr szTmpStr, addr szRetStr

	; SOURCE=...
	invoke lstrcat, addr szTmpStr, addr szSource
	invoke lstrcat, addr szTmpStr, addr szEquals
	invoke lstrcat, addr szTmpStr, addr szSourcePath
	invoke lstrcat, addr szTmpStr, addr szRetStr

	invoke lstrcat, addr szTmpStr, addr szRetStr

	; =============
	; Do "[sfiles]"
	; =============

	; [sfiles]
	invoke lstrcat, addr szTmpStr, addr szOpenSqBrac
	invoke lstrcat, addr szTmpStr, addr szSFiles
	invoke lstrcat, addr szTmpStr, addr szCloseSqBrac
	invoke lstrcat, addr szTmpStr, addr szRetStr
	
	; 1=...
	; 2=...
	; ...
	invoke AppendSFiles, addr szTmpStr

	invoke lstrcat, addr szTmpStr, addr szRetStr
	
	; ==========
	; setup Loop
	; ==========

	invoke lstrlen, addr szTmpStr
	lea ecx, szTmpStr
	add ecx, eax
	mov CurStrP, ecx

	mov CurOBJ, 00000000h
	
	invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_GETITEMCOUNT, 0, 0
	mov NumSections, eax
	
SaveToFile_Loop:

	; ====================
	; Copy the current OBJ
	; ====================
	
	invoke BinToStr, CurStrP, hWin, CurOBJ
	.if eax==FALSE
		ret
	.endif
	
	invoke lstrcat, addr szTmpStr, addr szRetStr
	
	invoke lstrlen, CurStrP
	add CurStrP, eax

	; ========================
	; increment & do end check
	; ========================
	
	inc CurOBJ
	mov eax, CurOBJ
	
	cmp eax, NumSections
	jne SaveToFile_Loop
	
	; =========
	; Write now
	; =========
	
	invoke PInfoExists
	invoke CreateFile, addr szCurFile, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, NULL, NULL
	mov hFile, eax
	.if eax!=INVALID_HANDLE_VALUE
		invoke lstrlen, addr szTmpStr
		mov ecx, eax
		invoke WriteFile, hFile, addr szTmpStr, ecx, addr nUseless, NULL
		
		invoke CloseHandle, hFile
	.endif

	
	mov eax, TRUE
	ret
SaveToFile endp

; ****************************************
; returns whether a project is open or not
; ****************************************

IsProjectOpen PROC

	; =====================================
	; Check appropriate member of ADDINDATA
	; =====================================


	mov edx, lpDStruct
	mov eax, [edx][ADDINDATA.fProject]

	ret
IsProjectOpen ENDP

; ***************************************************
; Checks whether a binary with the passed name exists
; ***************************************************

BinaryExists PROC pName:DWORD, iIgnore:DWORD, hWin:HWND
	LOCAL CurI:DWORD
	LOCAL CurP:DWORD
	
	; ==========
	; setup loop
	; ==========

	invoke lcase, pName

	invoke SendDlgItemMessage, hWin, IDC_BINTAB, TCM_GETITEMCOUNT, 0, 0
	mov NumSections, eax
	
	mov CurP, offset BSList
	add CurP, offset BinStruct.szName
	mov CurI, 00000000h
	
BinaryExists_Loop:

	; ====================
	; Check end conditions
	; ====================
	
	mov eax, CurI
	cmp eax, NumSections
	jne @F
	mov eax, FALSE
	ret
@@:

	; ===================================
	; Check whether this is to be ignored
	; ===================================
	
	cmp eax, iIgnore
	je BinaryExists_NextBS

	; ==============
	; Check this one
	; ==============
	
	invoke lstrcmp, CurP, pName
	test eax, eax
	jnz BinaryExists_NextBS
	mov eax, TRUE
	ret
	
BinaryExists_NextBS:

	; =========================
	; increment for loop & jump
	; =========================
	
	inc CurI
	add CurP, sizeof BinStruct
	jmp BinaryExists_Loop
BinaryExists ENDP

; ********************************************
; Copies the stem (with no added prename path)
; ********************************************

CopyRealStem PROC pDest:DWORD, pSrc:DWORD
	
	; =================
	; get string length
	; =================
	
	invoke lstrlen, pSrc
	.if eax==0
		mov eax, pDest
		mov byte ptr [eax], 00h
		
		ret
	.endif
	
	; ===============================
	; Search for the _LAST_ backslash
	; ===============================

	add eax, pSrc
	
@@:

	dec eax
	
	; ===============
	; Check this char
	; ===============

	cmp byte ptr [eax], '\'
	je CopyRealStem_ChopOther
	
	; ===================
	; Chck end conditions
	; ===================

	test eax, eax
	jnz @B
	
	mov eax, pDest
	mov byte ptr [eax], 00h
	
	ret
	
CopyRealStem_ChopOther:

	; =============
	; Copy and exit
	; =============

	inc eax
	
	invoke GetFName, pDest, eax
	
	ret
CopyRealStem ENDP

; ***********************************************
; Returns whether a make file name already exists
; ***********************************************

OutFileAlreadyExists PROC pFile:DWORD, nNumFiles:DWORD
	LOCAL szTmpStr[MAX_PATHSTR_LEN]:BYTE
	LOCAL CurP:DWORD
	LOCAL CurI:DWORD
	
	
	; ==========
	; setup loop
	; ==========

	mov CurP, offset OBJList
	mov CurI, 00000000h
	
OutFileAlreadyExists_Loop:

	; ====================
	; Check end conditions
	; ====================
	
	mov eax, CurI
	cmp eax, nNumFiles
	jne @F
	mov eax, FALSE
	ret
@@:

	; ==================
	; Get the stem first
	; ==================
	
	invoke GetFName, addr szTmpStr, CurP

	; ==============
	; Check this one
	; ==============
	
	invoke lstrcmp, pFile, addr szTmpStr
	test eax, eax
	jnz @F
	mov eax, TRUE
	ret
@@:

	; ============
	; do next loop
	; ============
	
	inc CurI
	add CurP, sizeof SFName
	jmp OutFileAlreadyExists_Loop
OutFileAlreadyExists ENDP

; ***********************************************************************
; Turns the ideal addresses for build files into the first available ones
; ***********************************************************************

MakeRelReal PROC pFile:DWORD, nNumFiles:DWORD
	LOCAL szTmpStr[MAX_PATHSTR_LEN]:BYTE
	LOCAL nNum:DWORD
	LOCAL NewP:DWORD

	; ===============
	; Check if its ok
	; ===============
	
	invoke OutFileAlreadyExists, pFile, nNumFiles
	.if eax==FALSE
		ret
	.endif
	
	; ==========
	; setup loop
	; ==========
	
	invoke lstrcpy, addr szTmpStr, pFile
	invoke lstrlen, pFile
	lea ecx, szTmpStr
	add eax, ecx
	mov NewP, eax

	mov nNum, 00000000h
	
MakeRelReal_Loop:

	; ==================
	; make number string
	; ==================
	
	invoke udwtoa, nNum, NewP
	
	; ==============
	; Check this one
	; ==============

	invoke OutFileAlreadyExists, addr szTmpStr, nNumFiles
	.if eax==FALSE
		invoke lstrcpy, pFile, addr szTmpStr
		ret
	.endif
	
	; ==============
	; Setup for next
	; ==============
	
	inc nNum
	jmp MakeRelReal_Loop
MakeRelReal ENDP

; ****************************************************
; Creates the whole directory tree for the build files
; ****************************************************

CreateBldDirTree PROC
	LOCAL CurIndex:DWORD
	LOCAL CurSubPath[MAX_PATHSTR_LEN]:BYTE

	; =================================================
	; Get the current path & append the build extension
	; =================================================
	
	mov edi, [lpDStruct]
	invoke lstrcpy, addr szCurPath, [edi][ADDINDATA.lpProjectPath]

	; ===========================================================
	; Check if the last letter is a backslash (and add if needed)
	; ===========================================================
	
	invoke lstrlen, addr szCurPath
	add eax, offset szCurPath
	mov cl, [eax-1]

	.if cl!=5Ch
		mov cx, 005Ch
		mov [eax], cl
		mov [eax+1], ch
	.endif

	; =================================================================
	; loop through all source files' build names and make each sub path
	; =================================================================

	mov CurIndex, 00000000h
	
CreateBldDirTree_Loop:

	; ==========================
	; Check its not the last one
	; ==========================

	mov eax, CurIndex
	.if eax==NumFiles
		ret
	.endif
	
	; =====================
	; Check that its an obj
	; =====================
	
	mov eax, sizeof SFName
	mul CurIndex
	add eax, offset SFNameList

	invoke GetExtension, eax
	.if (eax==EXTEN_ASM) || (eax==EXTEN_RC)
	
		; =================
		; Get this sub path
		; =================
		
		invoke GetFileSubPath, addr	CurSubPath, CurIndex
		
		; ==============
		; Make this path
		; ==============
		
		invoke MakeSubPath, addr szCurPath, addr CurSubPath

	.endif
	
	; ================
	; Add one and jump
	; ================
	
	inc CurIndex
	jmp CreateBldDirTree_Loop
CreateBldDirTree ENDP

; ************************************************************
; Creates a subpath from a main path (can be many sub folders)
; ************************************************************

MakeSubPath PROC szPath:DWORD, szAdd:DWORD
	LOCAL szFolder[MAX_PATHSTR_LEN]:BYTE

	; =======================
	; Check for a null string
	; =======================

	invoke lstrlen, szAdd
	.if eax==0
		ret
	.endif

	; ======================
	; Get the Project folder
	; ======================
	
	invoke lstrcpy, addr szFolder, szPath

	; =======================
	; Append the first folder
	; =======================
	
	invoke lstrlen, addr szFolder
	lea ecx, szFolder
	add ecx, eax
	
	invoke GetFirstFolder, ecx, szAdd
	
	; =============================
	; Check if the directory exists
	; =============================

	invoke CreateFile, addr szFolder, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, NULL, NULL
	.if eax==INVALID_HANDLE_VALUE
	
		; ----------------------------
		; It doesn't exist - create it
		; ----------------------------

		invoke CreateDirectory, addr szFolder, NULL
	.else	
		invoke CloseHandle, eax
	.endif
	
	; ====================
	; Do the sub directory
	; ====================

	invoke lstrlen, addr szFolder
	push eax
	invoke lstrlen, szPath
	pop ecx
	sub ecx, eax
	add ecx, szAdd
	
	invoke MakeSubPath, addr szFolder, ecx
	
	; ====
	; Exit
	; ====
	
	ret
MakeSubPath ENDP

; *****************************************************************
; Gets the sub path of the intermediate file specified by the index
; *****************************************************************

GetFileSubPath PROC szPath:DWORD, iFileOffs:DWORD
	LOCAL pStrStart:DWORD

	; =====================
	; Get file path pointer
	; =====================

	mov eax, sizeof SFName
	mul iFileOffs
	add eax, offset OBJList
	mov pStrStart, eax

	; ====================================
	; Get pointer to the end of the string
	; ====================================

	push eax
	invoke lstrlen, eax
	pop edi
	add edi, eax
	dec edi
	
	; =============================
	; search back for the backslash
	; =============================

@@:
	cmp edi, pStrStart
	je @F
	mov al, [edi]
	cmp al, '\'
	je @F
	dec edi
	jmp @B
@@:
	
	mov al, [edi]
	cmp al, '\'
	je @F
	
	; --------------
	; no backslashes
	; --------------

	xor eax, eax
	mov edi, szPath
	mov [edi], al
	ret

@@:
	; ----------------
	; backslash at edi
	; ----------------

	; ============================
	; Copy to output string & Exit
	; ============================

	sub edi, pStrStart
	mov ecx, edi
	inc ecx
	mov edi, szPath
	mov esi, pStrStart
	rep movsb
	
	xor eax, eax
	mov [edi], al
	
	ret
GetFileSubPath ENDP

; *********************************
; Return the first folder in a path
; *********************************

GetFirstFolder PROC szDest:DWORD, szPath:DWORD

	invoke lstrlen, szPath
	mov ecx, eax
	mov edi, szPath
	mov al, '\'
	
	; ========================
	; Check for a nulls srting
	; ========================
	
	test ecx, ecx
	jnz @F

	mov esi, szDest
	mov [esi], al
	ret
@@:

	; ==============================
	; Search for the first backslash
	; ==============================

	test ecx, ecx
	jz @F
	
	cmp [edi], al
	je @F
	
	inc edi
	dec ecx
	jmp @B
	
@@:
	; ==================
	; Is it a backslash?
	; ==================

	cmp al, [edi]
	je @F

	; --
	; no
	; --

	mov esi, szDest
	xor al, al
	mov [esi], al
	ret

@@:

	; ---
	; yes
	; ---

	; ==================
	; Copy the first bit
	; ==================
	
	sub edi, szPath
	mov ecx, edi
	inc ecx
	mov edi, szDest
	mov esi, szPath
	rep movsb
	
	mov byte ptr [edi], 00h
	
	; ======
	; Return
	; ======
	
	ret
GetFirstFolder ENDP

; **********************************************************************************
; Checks whether the current binary contains sufficient information to exit/swap tab
; **********************************************************************************

ParseCurBin PROC hWin:DWORD
	LOCAL szName[MAX_PATHSTR_LEN]:BYTE

	; ====================================
	; Get the current name from the dialog
	; ====================================

	invoke GetDlgItemText, hWin, IDC_BINNAME, addr szName, MAX_PATHSTR_LEN-1
	
	; ==========================
	; Check if its a NULL string
	; ==========================
	
	invoke lstrlen, addr szName
	.if eax==0
		mov eax, FALSE
	.else
		mov eax, TRUE
	.endif
	
	; =======================
	; Exit with correct value
	; =======================
	
	ret
ParseCurBin ENDP

end DllEntry
